/**
 * Hook into ControlsView initialize method
 */
wp.hooks.addAction('Huddle.ImageCollection.initialize', function( collection ){
    collection.phAddApproveListeners();
});

/**
 * Extend the original image collection
 * Adds new methods
 */
_.extend( Huddle.ImageCollection.prototype, {

    /**
     * Add approval listeners
     */
    phAddApproveListeners: function() {
        this.listenTo( this, 'approveImage', this.phSaveApproval );
    },

    /**
     * Save approval meta
     *
     * @param image Image model to update
     */
    phSaveApproval: function( image ) {
        image.approve( undefined, {
            success: function ( model, response ) {
                if ( response.success != false ) {
                    toastr.remove();
                    if ( model.attributes.approved ) {
                        toastr.success( Huddle.translations.approved, {timeOut: 2000} );
                    } else {
                        toastr.info( Huddle.translations.unapproved, {timeOut: 2000} );
                    }
                }
            },
            error: function ( model, xhr ) {
                console.error( xhr );
                toastr.error( 'Something went wrong. Please refresh the page and try again.' );
            }
        } );
    }

});