/**
 * Add our approval default
 */
_.extend( Huddle.Image.prototype.defaults, {
    approved: false
});

/**
 * Extend the original image model
 * Adds new approve method
 */
_.extend( Huddle.Image.prototype, {
    /**
     * Store a custom action for approving images
     *
     * @param attributes {object} Attributes to update
     * @param options {object} Options to extend from
     */
    approve: function ( attributes, options ) {
        options = _.defaults((options || {}), {
            data: {
                nonce: phApproval.phNonce, // pass our custom nonce
                action: 'ph_approve_image' // our ajax action
            }
        });
        return Backbone.Model.prototype.save.call(this, attributes, options);
    }
});