/**
 * Add our approval default
 */
_.extend( Huddle.Permissions.prototype.defaults, {
    allowApprovals: false
});

/**
 * Hook into permissions model initialize method
 */
wp.hooks.addAction( 'Huddle.Permissions.initialize', function( model ){
    model.phPermissionApproveInitialize();
});

/**
 * Extend the original image model
 * Adds new approve method
 */
_.extend( Huddle.Permissions.prototype, {

    /**
     * Add approval listeners
     */
    phPermissionApproveInitialize: function() {
        // check approvals
        this.allowApprovals();

        // set after identify success
        this.listenTo( Huddle.Event, 'identifySuccess', this.allowApprovals );
    },

    /**
     * Allow approvals/unapprovals if allowed
     */
    allowApprovals: function() {
        this.set({
            'allowApprovals': false,
            'allowUnapprovals': false
        });

        if ( Huddle.options.project.allow_approve != 'off' ) {
            this.set({
                'allowApprovals': true
            });
        }

        if ( Huddle.options.project.allow_unapprove != 'off' ) {
            this.set({
                'allowUnApprovals': true
            });
        }
    }

} );