/**
 * Holds the Approve Button
 *
 * @since 1.0.0
 */
Huddle.ApproveContainerView = Huddle.View.extend({
    className: 'ph-approval-wrap',
    tagName: 'span',

    initialize: function () {
        this.listenTo(Huddle.state, 'change:image', this.setView);
    },

    ready: function() {
        this.$el.find('[data-tip]').tipr({
            'speed': 300
        });
    },

    buttonDisabled: function() {
        var options = Huddle.options.project;
        return options.allow_approve === 'off' && options.allow_unapprove === 'off';
    },

    /**
     * Adds the approval button with the right image state
     *
     * @param state State model
     */
    setView: function (state) {
        // don't show if completely disabled
        if ( this.buttonDisabled() ) {
            return;
        }
        this.views.set(new Huddle.ApproveButtonView({
            model: this.model.images.get(state.get('image'))
        }));
    }
});