<?php
/**
 * Addon Meta Boxes
 *
 * @package    project-huddle
 * @subpackage ph-image-approvals
 */

/**
 * Add our approval options to the meta box
 *
 * @param $options array Array of options
 *
 * @return array Modified settings array
 *
 * @since 1.1.1
 */
function ph_approve_option( $options ) {
	$options[] = array(
		'id'          => 'project_approval',
		'label'       => __( 'Approvals', 'project-huddle' ),
		'description' => __( 'Enable approvals for this project', 'project-huddle' ),
		'type'        => 'checkbox',
		'default'     => 'on'
	);

	$options[] = array(
		'id'          => 'project_unapproval',
		'label'       => __( 'Unapprovals', 'project-huddle' ),
		'description' => __( 'Enable unapproval of approved images for this project', 'project-huddle' ),
		'type'        => 'checkbox',
		'default'     => 'on'
	);

	return $options;
}
add_filter( 'ph_project_meta_box_options', 'ph_approve_option' );

/**
 * Add approval meta box
 */
function pha_approval_meta_box() {
	// project images
	add_meta_box(
		'ph-project-approval-status', // unique id
		__( 'Approval Status', 'project-huddle' ), // title
		function() {
			echo '<div class="meta-approval-wrap">';
			ph_approval_badge();
			ph_approval_progress_bar();
			echo '</div>';
		},
		'ph-project', // post type to apply meta box
		'side', // position
		'high' // priority
	);
}
add_action( 'add_meta_boxes', 'pha_approval_meta_box', 9 );
