<?php
/**
 * Style Functions
 *
 * @package    project-huddle
 * @subpackage ph-image-approvals
 */

/**
 * Output approve button option to inline style
 * Happens during output buffer, so no need to worry about echo
 *
 * @since 1.1.1
 */
function ph_approve_style_output() { ?>
	<?php if ( $ph_unapprove_color = get_option( 'ph_unapprove_color') ) : ?>
		/* Unapprove Button */
		.projecthuddle #top-bar .controls a.ph-approved,
		.projecthuddle #top-bar .controls a.ph-approved:hover,
		.projecthuddle #top-bar .controls button.ph-approve-button.ph-approved,
		.projecthuddle #top-bar .controls button.ph-approve-button.ph-approved:hover,
		.projecthuddle #top-bar .controls .ph-icon.ph-approved,
		.projecthuddle #top-bar .controls .ph-icon.ph-approved:hover,
		.projecthuddle .toast-info {
		background-color: <?php echo apply_filters( 'ph_unapprove_color_output', esc_attr( $ph_unapprove_color ) ); ?>;
		}
	<?php endif; ?>

	<?php if ( $ph_approve_color = get_option( 'ph_approve_color') ) : ?>
		/* Approve Button */
		.projecthuddle #top-bar .controls a.ph-pending,
		.projecthuddle #top-bar .controls a.ph-pending:hover,
		.projecthuddle #top-bar .controls button.ph-approve-button.ph-pending,
		.projecthuddle #top-bar .controls button.ph-approve-button.ph-pending:hover,
		.projecthuddle #top-bar .controls .ph-icon.ph-pending,
		.projecthuddle #top-bar .controls .ph-icon.ph-pending:hover,
		.projecthuddle .toast-success {
		background-color: <?php echo apply_filters( 'ph_approve_color_output', esc_attr( $ph_approve_color ) ); ?>;
		}

		.ph-nav-thumb-link .ph-approval-indicator {
		color: <?php echo apply_filters( 'ph_approve_color_output', esc_attr( $ph_approve_color ) ); ?>;
		}
	<?php endif; ?>

<?php }
add_action( 'ph_style_options_output', 'ph_approve_style_output' );