<?php
/**
 * Approval Template Functions
 *
 * @package     ProjectHuddle
 * @subpackage  Image Approvals
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.1.1
 */

/**
 * Add approval templates
 *
 * @since 1.1.1
 */
function ph_output_approval_templates() {
	// version template
	ph_get_template( 'approve-button.tmpl.php', '', '', PH_APPROVALS_PLUGIN_DIR . 'templates/' );
	ph_get_template( 'approve-filter.tmpl.php', '', '', PH_APPROVALS_PLUGIN_DIR . 'templates/' );
}
add_action( 'ph_underscore_templates', 'ph_output_approval_templates' );

/**
 * Output containing div for filter in correct spot
 */
function ph_output_filter_area() {
    echo '<div class="ph-filter"></div>';
}
add_action('ph_image_tray_before', 'ph_output_filter_area');

/**
 * Add location of approve button
 *
 * @param $post object Post object
 *
 * @since 1.1.1
 */
function ph_approve_button_location( $post ) { ?>
	<!-- Approve Button -->
	<?php if ( 'off' != get_post_meta( $post->ID, 'ph_project_approval', true ) ) : ?>
		<span class="ph-approve-button-location"></span>
	<?php endif; ?>
<?php }
add_action( 'ph_after_user_settings', 'ph_approve_button_location' );