<?php
/**
 * Addon Translations
 *
 * @package project-huddle
 * @subpackage ph-image-approvals
 */

/**
 * Adds approval translations to project data
 *
 * @param $project
 *
 * @return array Merged array with approval translations
 *
 * @since 1.1.1
 */
function ph_approval_translations( $project ) {
	$approve_translations = array(
		'approve_image'       => __( 'Approve Image', 'project-huddle' ),
		'unapprove_image'     => __( 'Unapprove Image', 'project-huddle' ),
		'approve'             => __( 'Approve', 'project-huddle' ),
		'approved'            => __( 'Approved', 'project-huddle' ),
		'unapproved'          => __( 'UnApproved', 'project-huddle' ),
		'unapprove'           => __( 'UnApprove', 'project-huddle' ),
		'confirmApprove'      => sprintf( __( 'Are you sure you want to approve %s?', 'project-huddle' ), '<strong>{{image_name}}</strong>' ),
		'confirmUnApprove'    => sprintf( __( 'Are you sure you want to unapprove %s?', 'project-huddle' ), '<strong>{{image_name}}</strong>' ),
		'approveCheckbox'     => sprintf( __( 'I read and agree with the %s.', 'project-huddle' ), '{{terms}}' ),
		'approveCheckboxLink' => __( 'Terms', 'project-huddle' ),
		'approveProject'      => sprintf( __( 'Also %1$s the other %2$s images in this project.', 'project-huddle' ), '{{approval_status}}', '{{image_number}}' ),
		'approveTerms'        => '',
		'cant_approve'        => __( 'You\'re not allowed to approve.', 'project-huddle' ),
		'cant_unapprove'      => __( 'You\'re not allowed to unapprove.', 'project-huddle' )
	);

	$approve_translations = ph_add_approval_text_options($approve_translations);

	// add our translations
	$project['translations'] = array_merge($approve_translations, $project['translations']);

	// return translations
	return $project;
}
add_filter( 'ph_project_data', 'ph_approval_translations' );