/**
 * Extend defaults with our own
 */
_.extend( Huddle.Image.prototype.defaults, {
	version: 1,
	createDate: false,
	createTime: false,
	isoDate: false,
	currentVersion: false
});

/**
 * Hook into ImageView initialize model
 */
wp.hooks.addAction('Huddle.Image.initialize', function( model ){
	model.phvInitialize();
});

/**
 * Extending the image model prototype
 */
_.extend( Huddle.Image.prototype, {

	phvTime: false,

	phvInitialize: function() {

		// set default time to now
		this.phvTime = new Date();

		// set isodate if not set
		if ( ! this.attributes.isoDate ) {
			this.set('isoDate', this.phvTime.toISOString() );
		}

		// set create time if not set
		if ( ! this.attributes.createTime ) {
			this.set('createTime', this.phvTime.format('g:i a') );
		}

		// set create date if not set
		if ( ! this.attributes.createDate && Huddle.options.date_format ) {
			this.set('createDate', this.phvTime.format( Huddle.options.date_format ) );
		}

		// add our versions model in the image model
		this.versions = new Huddle.VersionsCollectionModel({
			collection: new Huddle.ImageVersionsCollection(
					this.versions ? this.versions.models : []
			),
			originalID: this.attributes.ID
		});
	},

    /**
     * Get options from settings
     */
    initialize: function () {
        // broadcast init
        wp.hooks.doAction('Huddle.Image.initialize', this);
    }
});