Huddle.VersionListItemView = Huddle.VersionsView.extend({
    template: wp.template('versions-list-item'),
    className: 'ph-version',

    events: {
        'click': 'clickHandler',
        'click .ph-restore': 'restoreImage'
    },

    ready: function () {
        // add current version class to current version
        if (this.model.get('id') == this.options.current) {
            this.$el.addClass('ph-version-selected ph-current-version');
        } else {
            this.$el.removeClass('ph-version-selected ph-current-version');
        }
    },

    /**
     * Handles click event for item
     */
    clickHandler: function () {
        this.clickClass();
        this.model.trigger('loadImage', this.model);
    },
    
    clickClass: function () {
        jQuery('.ph-version').removeClass('ph-version-selected');
        this.$el.addClass('ph-version-selected');
    },

    restoreImage: function () {
        this.model.trigger('restoreImage', this.model);
    }
});