<?php
/**
 * Output admin underscore templates
 *
 * @since 1.0.0
 */
function phv_output_admin_template() {
	global $typenow, $pagenow;

	// check correct post type
	if ( 'ph-project' != $typenow ) {
		return false;
	}

	// check correct page
	if ( 'post.php' != $pagenow && 'post-new.php' != $pagenow ) {
		return false;
	}

	ph_get_template( 'admin/versions-modal.tmpl.php', '', '', PH_VERSIONS_PLUGIN_DIR . 'templates/' );
	ph_get_template( 'admin/versions-menu-items.tmpl.php', '', '', PH_VERSIONS_PLUGIN_DIR . 'templates/' );
}
add_action( 'print_media_templates', 'phv_output_admin_template', 9 );


/**
 * Add links to menu
 */
function phv_add_versions_links_to_menu() {	?>
	<li class="ph-project-action ph-new-version"></li>
	<li class="ph-project-action ph-show-version"></li>
<?php }
add_action( 'ph_meta_box_image_settings_before_trash', 'phv_add_versions_links_to_menu' );

/**
 * Add version control dropdown to control bar
 * @future
 */
function phv_add_version_control() { ?>
	<button class="phv-toggle-versions phv-versions-trigger ph-dropdown click-trigger" data-mode="bottom" data-tip="<?php _e( 'Image Versions', 'project-huddle' ); ?>">
		<i class="ph-icon ion-social-buffer"></i>
		<span class="ph-version-dropdown hidden"></span>
	</button>
<?php }
//add_action( 'ph_before_control_settings', 'phv_add_version_control' );

/**
 * Add our version templates
 *
 * @future
 */
function phv_output_version_templates() {
	// version template
	ph_get_template( 'versions-menu.tmpl.php', '', '', PH_VERSIONS_PLUGIN_DIR . 'templates/' );
}
// add underscore templates
//add_action( 'ph_underscore_templates', 'phv_output_version_templates' );