/*!
 * clipboard.js v1.7.1
 * https://zenorocha.github.io/clipboard.js
 *
 * Licensed MIT © Zeno Rocha
 */
(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.Clipboard = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
var DOCUMENT_NODE_TYPE = 9;

/**
 * A polyfill for Element.matches()
 */
if (typeof Element !== 'undefined' && !Element.prototype.matches) {
    var proto = Element.prototype;

    proto.matches = proto.matchesSelector ||
                    proto.mozMatchesSelector ||
                    proto.msMatchesSelector ||
                    proto.oMatchesSelector ||
                    proto.webkitMatchesSelector;
}

/**
 * Finds the closest parent that matches a selector.
 *
 * @param {Element} element
 * @param {String} selector
 * @return {Function}
 */
function closest (element, selector) {
    while (element && element.nodeType !== DOCUMENT_NODE_TYPE) {
        if (typeof element.matches === 'function' &&
            element.matches(selector)) {
          return element;
        }
        element = element.parentNode;
    }
}

module.exports = closest;

},{}],2:[function(require,module,exports){
var closest = require('./closest');

/**
 * Delegates event to a selector.
 *
 * @param {Element} element
 * @param {String} selector
 * @param {String} type
 * @param {Function} callback
 * @param {Boolean} useCapture
 * @return {Object}
 */
function delegate(element, selector, type, callback, useCapture) {
    var listenerFn = listener.apply(this, arguments);

    element.addEventListener(type, listenerFn, useCapture);

    return {
        destroy: function() {
            element.removeEventListener(type, listenerFn, useCapture);
        }
    }
}

/**
 * Finds closest match and invokes callback.
 *
 * @param {Element} element
 * @param {String} selector
 * @param {String} type
 * @param {Function} callback
 * @return {Function}
 */
function listener(element, selector, type, callback) {
    return function(e) {
        e.delegateTarget = closest(e.target, selector);

        if (e.delegateTarget) {
            callback.call(element, e);
        }
    }
}

module.exports = delegate;

},{"./closest":1}],3:[function(require,module,exports){
/**
 * Check if argument is a HTML element.
 *
 * @param {Object} value
 * @return {Boolean}
 */
exports.node = function(value) {
    return value !== undefined
        && value instanceof HTMLElement
        && value.nodeType === 1;
};

/**
 * Check if argument is a list of HTML elements.
 *
 * @param {Object} value
 * @return {Boolean}
 */
exports.nodeList = function(value) {
    var type = Object.prototype.toString.call(value);

    return value !== undefined
        && (type === '[object NodeList]' || type === '[object HTMLCollection]')
        && ('length' in value)
        && (value.length === 0 || exports.node(value[0]));
};

/**
 * Check if argument is a string.
 *
 * @param {Object} value
 * @return {Boolean}
 */
exports.string = function(value) {
    return typeof value === 'string'
        || value instanceof String;
};

/**
 * Check if argument is a function.
 *
 * @param {Object} value
 * @return {Boolean}
 */
exports.fn = function(value) {
    var type = Object.prototype.toString.call(value);

    return type === '[object Function]';
};

},{}],4:[function(require,module,exports){
var is = require('./is');
var delegate = require('delegate');

/**
 * Validates all params and calls the right
 * listener function based on its target type.
 *
 * @param {String|HTMLElement|HTMLCollection|NodeList} target
 * @param {String} type
 * @param {Function} callback
 * @return {Object}
 */
function listen(target, type, callback) {
    if (!target && !type && !callback) {
        throw new Error('Missing required arguments');
    }

    if (!is.string(type)) {
        throw new TypeError('Second argument must be a String');
    }

    if (!is.fn(callback)) {
        throw new TypeError('Third argument must be a Function');
    }

    if (is.node(target)) {
        return listenNode(target, type, callback);
    }
    else if (is.nodeList(target)) {
        return listenNodeList(target, type, callback);
    }
    else if (is.string(target)) {
        return listenSelector(target, type, callback);
    }
    else {
        throw new TypeError('First argument must be a String, HTMLElement, HTMLCollection, or NodeList');
    }
}

/**
 * Adds an event listener to a HTML element
 * and returns a remove listener function.
 *
 * @param {HTMLElement} node
 * @param {String} type
 * @param {Function} callback
 * @return {Object}
 */
function listenNode(node, type, callback) {
    node.addEventListener(type, callback);

    return {
        destroy: function() {
            node.removeEventListener(type, callback);
        }
    }
}

/**
 * Add an event listener to a list of HTML elements
 * and returns a remove listener function.
 *
 * @param {NodeList|HTMLCollection} nodeList
 * @param {String} type
 * @param {Function} callback
 * @return {Object}
 */
function listenNodeList(nodeList, type, callback) {
    Array.prototype.forEach.call(nodeList, function(node) {
        node.addEventListener(type, callback);
    });

    return {
        destroy: function() {
            Array.prototype.forEach.call(nodeList, function(node) {
                node.removeEventListener(type, callback);
            });
        }
    }
}

/**
 * Add an event listener to a selector
 * and returns a remove listener function.
 *
 * @param {String} selector
 * @param {String} type
 * @param {Function} callback
 * @return {Object}
 */
function listenSelector(selector, type, callback) {
    return delegate(document.body, selector, type, callback);
}

module.exports = listen;

},{"./is":3,"delegate":2}],5:[function(require,module,exports){
function select(element) {
    var selectedText;

    if (element.nodeName === 'SELECT') {
        element.focus();

        selectedText = element.value;
    }
    else if (element.nodeName === 'INPUT' || element.nodeName === 'TEXTAREA') {
        var isReadOnly = element.hasAttribute('readonly');

        if (!isReadOnly) {
            element.setAttribute('readonly', '');
        }

        element.select();
        element.setSelectionRange(0, element.value.length);

        if (!isReadOnly) {
            element.removeAttribute('readonly');
        }

        selectedText = element.value;
    }
    else {
        if (element.hasAttribute('contenteditable')) {
            element.focus();
        }

        var selection = window.getSelection();
        var range = document.createRange();

        range.selectNodeContents(element);
        selection.removeAllRanges();
        selection.addRange(range);

        selectedText = selection.toString();
    }

    return selectedText;
}

module.exports = select;

},{}],6:[function(require,module,exports){
function E () {
  // Keep this empty so it's easier to inherit from
  // (via https://github.com/lipsmack from https://github.com/scottcorgan/tiny-emitter/issues/3)
}

E.prototype = {
  on: function (name, callback, ctx) {
    var e = this.e || (this.e = {});

    (e[name] || (e[name] = [])).push({
      fn: callback,
      ctx: ctx
    });

    return this;
  },

  once: function (name, callback, ctx) {
    var self = this;
    function listener () {
      self.off(name, listener);
      callback.apply(ctx, arguments);
    };

    listener._ = callback
    return this.on(name, listener, ctx);
  },

  emit: function (name) {
    var data = [].slice.call(arguments, 1);
    var evtArr = ((this.e || (this.e = {}))[name] || []).slice();
    var i = 0;
    var len = evtArr.length;

    for (i; i < len; i++) {
      evtArr[i].fn.apply(evtArr[i].ctx, data);
    }

    return this;
  },

  off: function (name, callback) {
    var e = this.e || (this.e = {});
    var evts = e[name];
    var liveEvents = [];

    if (evts && callback) {
      for (var i = 0, len = evts.length; i < len; i++) {
        if (evts[i].fn !== callback && evts[i].fn._ !== callback)
          liveEvents.push(evts[i]);
      }
    }

    // Remove event from queue to prevent memory leak
    // Suggested by https://github.com/lazd
    // Ref: https://github.com/scottcorgan/tiny-emitter/commit/c6ebfaa9bc973b33d110a84a307742b7cf94c953#commitcomment-5024910

    (liveEvents.length)
      ? e[name] = liveEvents
      : delete e[name];

    return this;
  }
};

module.exports = E;

},{}],7:[function(require,module,exports){
(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['module', 'select'], factory);
    } else if (typeof exports !== "undefined") {
        factory(module, require('select'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod, global.select);
        global.clipboardAction = mod.exports;
    }
})(this, function (module, _select) {
    'use strict';

    var _select2 = _interopRequireDefault(_select);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
        return typeof obj;
    } : function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    var ClipboardAction = function () {
        /**
         * @param {Object} options
         */
        function ClipboardAction(options) {
            _classCallCheck(this, ClipboardAction);

            this.resolveOptions(options);
            this.initSelection();
        }

        /**
         * Defines base properties passed from constructor.
         * @param {Object} options
         */


        _createClass(ClipboardAction, [{
            key: 'resolveOptions',
            value: function resolveOptions() {
                var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

                this.action = options.action;
                this.container = options.container;
                this.emitter = options.emitter;
                this.target = options.target;
                this.text = options.text;
                this.trigger = options.trigger;

                this.selectedText = '';
            }
        }, {
            key: 'initSelection',
            value: function initSelection() {
                if (this.text) {
                    this.selectFake();
                } else if (this.target) {
                    this.selectTarget();
                }
            }
        }, {
            key: 'selectFake',
            value: function selectFake() {
                var _this = this;

                var isRTL = document.documentElement.getAttribute('dir') == 'rtl';

                this.removeFake();

                this.fakeHandlerCallback = function () {
                    return _this.removeFake();
                };
                this.fakeHandler = this.container.addEventListener('click', this.fakeHandlerCallback) || true;

                this.fakeElem = document.createElement('textarea');
                // Prevent zooming on iOS
                this.fakeElem.style.fontSize = '12pt';
                // Reset box model
                this.fakeElem.style.border = '0';
                this.fakeElem.style.padding = '0';
                this.fakeElem.style.margin = '0';
                // Move element out of screen horizontally
                this.fakeElem.style.position = 'absolute';
                this.fakeElem.style[isRTL ? 'right' : 'left'] = '-9999px';
                // Move element to the same position vertically
                var yPosition = window.pageYOffset || document.documentElement.scrollTop;
                this.fakeElem.style.top = yPosition + 'px';

                this.fakeElem.setAttribute('readonly', '');
                this.fakeElem.value = this.text;

                this.container.appendChild(this.fakeElem);

                this.selectedText = (0, _select2.default)(this.fakeElem);
                this.copyText();
            }
        }, {
            key: 'removeFake',
            value: function removeFake() {
                if (this.fakeHandler) {
                    this.container.removeEventListener('click', this.fakeHandlerCallback);
                    this.fakeHandler = null;
                    this.fakeHandlerCallback = null;
                }

                if (this.fakeElem) {
                    this.container.removeChild(this.fakeElem);
                    this.fakeElem = null;
                }
            }
        }, {
            key: 'selectTarget',
            value: function selectTarget() {
                this.selectedText = (0, _select2.default)(this.target);
                this.copyText();
            }
        }, {
            key: 'copyText',
            value: function copyText() {
                var succeeded = void 0;

                try {
                    succeeded = document.execCommand(this.action);
                } catch (err) {
                    succeeded = false;
                }

                this.handleResult(succeeded);
            }
        }, {
            key: 'handleResult',
            value: function handleResult(succeeded) {
                this.emitter.emit(succeeded ? 'success' : 'error', {
                    action: this.action,
                    text: this.selectedText,
                    trigger: this.trigger,
                    clearSelection: this.clearSelection.bind(this)
                });
            }
        }, {
            key: 'clearSelection',
            value: function clearSelection() {
                if (this.trigger) {
                    this.trigger.focus();
                }

                window.getSelection().removeAllRanges();
            }
        }, {
            key: 'destroy',
            value: function destroy() {
                this.removeFake();
            }
        }, {
            key: 'action',
            set: function set() {
                var action = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'copy';

                this._action = action;

                if (this._action !== 'copy' && this._action !== 'cut') {
                    throw new Error('Invalid "action" value, use either "copy" or "cut"');
                }
            },
            get: function get() {
                return this._action;
            }
        }, {
            key: 'target',
            set: function set(target) {
                if (target !== undefined) {
                    if (target && (typeof target === 'undefined' ? 'undefined' : _typeof(target)) === 'object' && target.nodeType === 1) {
                        if (this.action === 'copy' && target.hasAttribute('disabled')) {
                            throw new Error('Invalid "target" attribute. Please use "readonly" instead of "disabled" attribute');
                        }

                        if (this.action === 'cut' && (target.hasAttribute('readonly') || target.hasAttribute('disabled'))) {
                            throw new Error('Invalid "target" attribute. You can\'t cut text from elements with "readonly" or "disabled" attributes');
                        }

                        this._target = target;
                    } else {
                        throw new Error('Invalid "target" value, use a valid Element');
                    }
                }
            },
            get: function get() {
                return this._target;
            }
        }]);

        return ClipboardAction;
    }();

    module.exports = ClipboardAction;
});

},{"select":5}],8:[function(require,module,exports){
(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['module', './clipboard-action', 'tiny-emitter', 'good-listener'], factory);
    } else if (typeof exports !== "undefined") {
        factory(module, require('./clipboard-action'), require('tiny-emitter'), require('good-listener'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod, global.clipboardAction, global.tinyEmitter, global.goodListener);
        global.clipboard = mod.exports;
    }
})(this, function (module, _clipboardAction, _tinyEmitter, _goodListener) {
    'use strict';

    var _clipboardAction2 = _interopRequireDefault(_clipboardAction);

    var _tinyEmitter2 = _interopRequireDefault(_tinyEmitter);

    var _goodListener2 = _interopRequireDefault(_goodListener);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
        return typeof obj;
    } : function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var Clipboard = function (_Emitter) {
        _inherits(Clipboard, _Emitter);

        /**
         * @param {String|HTMLElement|HTMLCollection|NodeList} trigger
         * @param {Object} options
         */
        function Clipboard(trigger, options) {
            _classCallCheck(this, Clipboard);

            var _this = _possibleConstructorReturn(this, (Clipboard.__proto__ || Object.getPrototypeOf(Clipboard)).call(this));

            _this.resolveOptions(options);
            _this.listenClick(trigger);
            return _this;
        }

        /**
         * Defines if attributes would be resolved using internal setter functions
         * or custom functions that were passed in the constructor.
         * @param {Object} options
         */


        _createClass(Clipboard, [{
            key: 'resolveOptions',
            value: function resolveOptions() {
                var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

                this.action = typeof options.action === 'function' ? options.action : this.defaultAction;
                this.target = typeof options.target === 'function' ? options.target : this.defaultTarget;
                this.text = typeof options.text === 'function' ? options.text : this.defaultText;
                this.container = _typeof(options.container) === 'object' ? options.container : document.body;
            }
        }, {
            key: 'listenClick',
            value: function listenClick(trigger) {
                var _this2 = this;

                this.listener = (0, _goodListener2.default)(trigger, 'click', function (e) {
                    return _this2.onClick(e);
                });
            }
        }, {
            key: 'onClick',
            value: function onClick(e) {
                var trigger = e.delegateTarget || e.currentTarget;

                if (this.clipboardAction) {
                    this.clipboardAction = null;
                }

                this.clipboardAction = new _clipboardAction2.default({
                    action: this.action(trigger),
                    target: this.target(trigger),
                    text: this.text(trigger),
                    container: this.container,
                    trigger: trigger,
                    emitter: this
                });
            }
        }, {
            key: 'defaultAction',
            value: function defaultAction(trigger) {
                return getAttributeValue('action', trigger);
            }
        }, {
            key: 'defaultTarget',
            value: function defaultTarget(trigger) {
                var selector = getAttributeValue('target', trigger);

                if (selector) {
                    return document.querySelector(selector);
                }
            }
        }, {
            key: 'defaultText',
            value: function defaultText(trigger) {
                return getAttributeValue('text', trigger);
            }
        }, {
            key: 'destroy',
            value: function destroy() {
                this.listener.destroy();

                if (this.clipboardAction) {
                    this.clipboardAction.destroy();
                    this.clipboardAction = null;
                }
            }
        }], [{
            key: 'isSupported',
            value: function isSupported() {
                var action = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ['copy', 'cut'];

                var actions = typeof action === 'string' ? [action] : action;
                var support = !!document.queryCommandSupported;

                actions.forEach(function (action) {
                    support = support && !!document.queryCommandSupported(action);
                });

                return support;
            }
        }]);

        return Clipboard;
    }(_tinyEmitter2.default);

    /**
     * Helper function to retrieve attribute value.
     * @param {String} suffix
     * @param {Element} element
     */
    function getAttributeValue(suffix, element) {
        var attribute = 'data-clipboard-' + suffix;

        if (!element.hasAttribute(attribute)) {
            return;
        }

        return element.getAttribute(attribute);
    }

    module.exports = Clipboard;
});

},{"./clipboard-action":7,"good-listener":4,"tiny-emitter":6}]},{},[8])(8)
});
'use strict';

/**
 * Initialise the PH_API.
 */
function PH_API() {
    this.site        = {};
    this.current     = {};
    this.me          = {};
    this.global      = {};
    this.models      = {};
    this.collections = {};
    this.views       = {};
}

window.ph    = window.ph || {};
ph.api       = ph.api || new PH_API();
ph.api.utils = ph.api.utils || {};

// global parent selectors
ph.api.parent           = jQuery(parent.document);
ph.api.parent.window    = jQuery(window.parent);
ph.api.parent.html      = ph.api.parent.find('html');
ph.api.parent.body      = ph.api.parent.find('body');

// handle errors
jQuery(document).ajaxError(function (event, response, settings, exception) {
    console.error(arguments);

    if (typeof response.responseJSON !== 'undefined') {
        var error = response.responseJSON;

        // expired nonce
        if ( error.code === 'rest_cookie_invalid_nonce') {
            alert( 'Your session has expired. Please refresh the page and try again!' );
            return;
        }

        // whitelist a few
        if ( error.code === 'existing_user_email' ) {
            return;
        }

        // error code
        alert(response.responseJSON.message);
    }
});
/**
 * App.js
 * @since 1.0
 */
'use strict';

/**
 * Start App
 * @since 3.0.0
 */
ph.api.start = function (data) {
    ph.api.setGlobal(data);

    // create website container view and inject
    ph.api.container = new ph.api.views.Website({
        model: new ph.api.models.Website(data)
    });
    ph.api.container.inject('#project_pages_container');
};

ph.api.url = wpApiSettings.root + 'projecthuddle/v1/';

// global namespace
var phSite = window.phSite = {

    setGlobals: function (data) {
        // create user model
        this.user = data ? new phSite.User( data.user ) : new phSite.User();

        // editor options
        this.editorOptions = ['bold', 'italic', 'blockquote', 'code-block', 'link', { 'list': 'ordered'}, { 'list': 'bullet' }];
        this.editorFormats = ['bold', 'italic', 'blockquote', 'code-block', 'link', 'list', 'code', 'image'];

        // set convenience permissions
        this.permissions = new this.Permissions();
    },

    setLinkPlaceholder: function (quill) {
        var input          = quill.theme.tooltip.root.querySelector("input[data-link]");
        input.dataset.link = 'http://';
    },

    isWhitespace: function (ch) {
        var whiteSpace = false;
        if ((ch == ' ') || (ch == '\t') || (ch == '\n')) {
            whiteSpace = true;
        }
        return whiteSpace;
    },

    // Autolink URLs when typing or pasting
    autoLinkHighlight: function(quill) {
        quill.on('text-change', _.bind( function(delta, oldDelta, source) {
            var regex = /https?:\/\/[^\s]+$/;
            if(delta.ops.length === 2 && delta.ops[0].retain && this.isWhitespace(delta.ops[1].insert)) {
                var endRetain = delta.ops[0].retain;
                var text = quill.getText().substr(0, endRetain);
                var match = text.match(regex);

                if(match !== null) {
                    var url = match[0];

                    var ops = [];
                    if(endRetain > url.length) {
                        ops.push({ retain: endRetain - url.length });
                    }

                    ops = ops.concat([
                        { delete: url.length },
                        { insert: url, attributes: { link: url } }
                    ]);

                    quill.updateContents({
                        ops: ops
                    });
                }
            }
        }, this ));

        quill.clipboard.addMatcher(Node.TEXT_NODE, function(node, delta) {
            var regex = /https?:\/\/[^\s]+/g;
            if(typeof(node.data) !== 'string') return;
            var matches = node.data.match(regex);

            if(matches && matches.length > 0) {
                var ops = [];
                var str = node.data;
                matches.forEach(function(match) {
                    var split = str.split(match);
                    var beforeLink = split.shift();
                    ops.push({ insert: beforeLink });
                    ops.push({ insert: match, attributes: { link: match } });
                    str = split.join(match);
                });
                ops.push({ insert: str });
                delta.ops = ops;
            }

            return delta;
        });
    }
};
/**
 * Mixins used in the app.
 *
 * @package     ProjectHuddle
 * @subpackage  js
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.2.0
 */

/**
 * A model for all the syncable models to extend
 *
 * Adds toast errors if they exist
 *
 * @since 1.0.0
 */
var phModel = Backbone.Model.extend({
    // log errors
    parse: function (response) {
        if (response.success == false) {
            console.error(response);
        }
        return response;
    },
    // add nonce
    sync: function (method, model, options) {
        options.beforeSend = function(xhr) {
            xhr.setRequestHeader('X-WP-Nonce', PH.nonce);
        };
        return Backbone.sync.apply(this, arguments);
    }
});

/**
 * A collection for all the syncable collections to extend
 *
 * @since 1.0.0
 */
var phCollection = Backbone.Collection.extend({
    // log errors
    parse: function (response) {
        if (response.success == false) {
            console.error(response);
        }
        return response;
    },
    // add nonce
    sync: function (method, model, options) {
        options.beforeSend = function(xhr) {
            xhr.setRequestHeader('X-WP-Nonce', PH.nonce);
        };
        return Backbone.sync.apply(this, arguments);
    }
});

/**
 * A view for all wp views to extend
 *
 * Extends wp.Backbone.View with .prepare() and .inject()
 *
 * @since 1.2.0
 */
ph.api.View = wp.Backbone.View.extend({
    inject: function( selector ) {
        this.render();
        jQuery(selector).html( this.el );
        this.views.ready();
    },

    prepare: function() {
        if ( ! _.isUndefined( this.model ) && _.isFunction( this.model.toJSON ) ) {
            this._parseTriggers();
            return this.model.toJSON();
        } else {
            return {};
        }
    },

    _parseTriggers: function () {
        if ( this.triggers ) {
            _.each( this.triggers || {}, function ( fn, event ) {

                // objects
                if ( typeof fn == 'object' ) {
                    _.each(fn, function (fn) {
                        var oHandler = this[fn];
                        if ( _.isFunction( oHandler ) ) {
                            this.stopListening( this.model, event, oHandler );
                            this.listenTo( this.model, event, oHandler );
                        }
                    }, this);
                    return false;
                }

                // regular
                var handler = this[fn];
                if ( _.isFunction( handler ) ) {
                    this.stopListening( this.model, event, handler );
                    this.listenTo( this.model, event, handler );
                }
            }, this );
        }
    }
});

/**
 * Underscore Mixins
 *
 * @since 1.0.0
 */
_.mixin( {
    /**
     * Convert /n newline to <br>
     *
     * @param str String to convert
     * @param is_xhtml Use xhtml tag
     * @returns {string} Output with <br> tag
     *
     * @since 1.0.0
     */
    nl2br: function ( str, is_xhtml ) {
        var breakTag = (is_xhtml || typeof is_xhtml === 'undefined') ? '<br />' : '<br>';
        return (str + '').replace( /([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1' + breakTag + '$2' );
    },

    /**
     * Human readable time
     *
     * @param time
     * @returns {*}
     */
    timeSince: function (time) {
        switch (typeof time) {
            case 'number':
                break;
            case 'string':
                time = +new Date(time);
                break;
            case 'object':
                if (time.constructor === Date) time = time.getTime();
                break;
            default:
                time = +new Date();
        }

        var time_formats = [
            [60, 's', 1], // 60
            [120, '1m', '1m'], // 60*2
            [3600, 'm', 60], // 60*60, 60
            [7200, '1h', '1h'], // 60*60*2
            [86400, 'h', 3600], // 60*60*24, 60*60
            [172800, '1d', '1d'], // 60*60*24*2
            [604800, 'd', 86400], // 60*60*24*7, 60*60*24
            [1209600, '1w', '1w'], // 60*60*24*7*4*2
            [2419200, 'w', 604800], // 60*60*24*7*4, 60*60*24*7
            [4838400, '1mth', '1mth'], // 60*60*24*7*4*2
            [29030400, 'mths', 2419200], // 60*60*24*7*4*12, 60*60*24*7*4
            [58060800, 'y', '1y'], // 60*60*24*7*4*12*2
            [2903040000, 'y', 29030400] // 60*60*24*7*4*12*100, 60*60*24*7*4*12
        ];

        // use gmt
        var now     = new Date();
        var now_utc = new Date(now.getUTCFullYear(), now.getUTCMonth(), now.getUTCDate(), now.getUTCHours(), now.getUTCMinutes(), now.getUTCSeconds());

        var seconds     = (+now_utc.getTime() - time) / 1000,
            token       = 'ago',
            list_choice = 1;

        if (seconds == 0) {
            return 'Now'
        }
        if (seconds < 0) {
            seconds     = Math.abs(seconds);
            token       = 'from now';
            list_choice = 2;
        }
        var i = 0,
            format;
        while (format = time_formats[i++]) {
            if (seconds < format[0]) {
                if (typeof format[2] === 'string')
                    return format[list_choice];
                else
                    return Math.floor(seconds / format[2]) + format[1];
            }
        }
        return time;
    }
} );

ph.api.setGlobal = function(data) {

    ph.api.me   = new wp.api.models.UsersMe(data.me || {});

    // global project users collection
    ph.api.users = data.users;

    ph.api.project_id = data.id;

    ph.api.comment_scroll = data.comment_scroll;

    // editor options
    ph.api.editor = {};
    ph.api.editor.editorOptions = ['bold', 'italic', 'blockquote', 'code-block', 'link', { 'list': 'ordered'}, { 'list': 'bullet' }];
    ph.api.editor.editorFormats = ['bold', 'italic', 'blockquote', 'code-block', 'link', 'list', 'code', 'image'];

    ph.api.editor.setLinkPlaceholder = function (quill) {
        var input          = quill.theme.tooltip.root.querySelector("input[data-link]");
        input.dataset.link = 'http://';
    };

    ph.api.editor.isWhitespace = function (ch) {
        var whiteSpace = false;
        if ((ch == ' ') || (ch == '\t') || (ch == '\n')) {
            whiteSpace = true;
        }
        return whiteSpace;
    };

    // Autolink URLs when typing or pasting
    ph.api.editor.autoLinkHighlight = function(quill) {
        quill.on('text-change', _.bind( function(delta, oldDelta, source) {
            var regex = /https?:\/\/[^\s]+$/;
            if(delta.ops.length === 2 && delta.ops[0].retain && ph.api.editor.isWhitespace(delta.ops[1].insert)) {
                var endRetain = delta.ops[0].retain;
                var text = quill.getText().substr(0, endRetain);
                var match = text.match(regex);

                if(match !== null) {
                    var url = match[0];

                    var ops = [];
                    if(endRetain > url.length) {
                        ops.push({ retain: endRetain - url.length });
                    }

                    ops = ops.concat([
                        { delete: url.length },
                        { insert: url, attributes: { link: url } }
                    ]);

                    quill.updateContents({
                        ops: ops
                    });
                }
            }
        }, this ));

        quill.clipboard.addMatcher(Node.TEXT_NODE, function(node, delta) {
            var regex = /https?:\/\/[^\s]+/g;
            if(typeof(node.data) !== 'string') return;
            var matches = node.data.match(regex);

            if(matches && matches.length > 0) {
                var ops = [];
                var str = node.data;
                matches.forEach(function(match) {
                    var split = str.split(match);
                    var beforeLink = split.shift();
                    ops.push({ insert: beforeLink });
                    ops.push({ insert: match, attributes: { link: match } });
                    str = split.join(match);
                });
                ops.push({ insert: str });
                delta.ops = ops;
            }

            return delta;
        });
    }
};
/**
 * Declare global events in namespace
 */
ph.api.Event = _.extend({}, Backbone.Events);
/**
 * Model to store our comment filter data
 *
 * @since 2.5.0
 */
ph.api.models.CommentFilter = Backbone.Model.extend({
    defaults: {
        'name': '',
        'active': false
    }
});
/**
 * Model to store our individual comment item
 *
 * @since 2.0.0
 */
ph.api.models.Comment = wp.api.models.Comment.extend({
    // extend defaults
    defaults: _.defaults({}, wp.api.models.Comment.prototype.defaults, {
        'edit'    : false,
        'moderate': false
    }),
    initialize: function (attributes, options) {
        wp.api.models.Comment.prototype.initialize.call(this, attributes, options);

        this.set({
            'humanDate': this.get('date_gmt') ? _.timeSince(this.get('date_gmt')) : 'Now',
            'moderate': this.get('author') === ph.api.me.get('id')
        });
    }
});
/**
 * Model to store our individual comment item
 *
 * @since 2.0.0
 */
ph.api.models.User = wp.api.models.User.extend();
/**
 * Website Thread
 */
ph.api.models.WebsitePage = wp.api.models.WebsitePage.extend({
    // extend defaults
    defaults: _.extend({}, wp.api.models.WebsitePage.prototype.defaults, {
        'comment_count'   : 0,
        'resolved_count'  : 0,
        'filter'          : 'all',
        'unresolved_count': 0,
        'parent_id'       : 0,
        'controls'        : '',
        'commentsEnabled' : false
    }),

    threads: {},

    filters: {},

    initialize: function (attributes, options) {
        // init parent
        wp.api.models.WebsitePage.prototype.initialize.call(this, attributes, options);

        // store threads outside attributes
        this.threads = new ph.api.collections.WebsiteThread(this.get('threads') || []);
        this.unset('threads');

        this.listenTo(this, 'change:filter', this.counts);

        // when threads are added to the collection, set the order in the model automatically
        this.listenTo(this.threads, 'change:resolved add remove', this.counts);
        this.listenTo(this.threads, 'submit', this.new);

        this.listenTo(this.threads, 'sorted', this.updateOrder);

        this.counts();
        this.orderThreads();
    },

    // model counts
    counts: function () {
        this.set('comment_count', this.threads.length);
        this.set('resolved_count', this.resolvedThreads().length);
        this.set('unresolved_count', this.unresolvedThreads().length);
    },

    /**
     * Sort using user order
     * Based on http://stackoverflow.com/questions/13304543/javascript-sort-array-based-on-another-array
     */
    orderThreads: function () {
        if (!this.get('user_order')) {
            return;
        }
        var order = _.compact(_.map(this.get('user_order'), function (i) {
            return typeof this.threads.get(i) !== 'undefined' && this.threads.get(i);
        }, this));
        this.threads.models = _.union(order, this.threads.models);
    },

    unresolvedThreads: function() {
        return this.threads['filter_' + this.get('filter')]().where({resolved: false});
    },

    resolvedThreads: function() {
        return this.threads['filter_' + this.get('filter')]().where({resolved: true});
    },

    filteredThreads: function() {
        return this.threads['filter_' + this.get('filter')]();
    },

    // selected filter model
    filter: function(model) {
        this.set('filter', model.attributes);
    },

    // Update the order attribute for all comments
    updateOrder: function (model, position) {
        this.threads.remove(model);

        this.threads.each(function (model, index) {
            var ordinal = index;
            if (index >= position) {
                ordinal += 1;
            }
            model.set('ordinal', ordinal);
        });

        model.set('ordinal', position);
        this.threads.add(model, {at: position});
        var ids = this.threads.pluck('id');

        jQuery.ajax({
            type: "POST",
            data: {
                ids: ids,
                user_id: ph.api.me.get('id')
            },
            beforeSend: function ( xhr ) {
                xhr.setRequestHeader('X-WP-Nonce', PH.nonce);
            },
            url: ph.api.url + 'website/thread/reorder/' + this.get('id')
        });
    }
});
/**
 * Website Thread
 */
ph.api.models.WebsiteThread = wp.api.models.WebsiteThread.extend({
    // extend defaults
    defaults: _.defaults({}, wp.api.models.WebsiteThread.prototype.defaults, {
        title             : '',
        author_avatar_urls: {},
        count             : 0,
        canEdit           : false,
        canDelete         : false,
        content           : '',
        formContent       : '',
        author_name       : '',
        controls          : false,
        focus             : false,
        domain            : false,
        location          : false,
        highlight         : false,
        siteTitle         : false,
        show              : false,
        diff              : 0,
        parent_id         : 0,
        assigned          : 0,
        assigned_model    : {
            avatar_urls: {
                96: ''
            },
            name: ''
        },
        humanDate         : '',
        order             : 0
    }),

    validate: function(attrs) {
        attrs.resolved = !!+attrs.resolved;
        attrs.assigned = parseInt(attrs.assigned);
    },

    comments: {},

    initialize: function (attributes, options) {
        // init parent
        wp.api.models.WebsiteThread.prototype.initialize.call(this, attributes, options);

        this.comments = new ph.api.collections.Comments(this.get('comments') || []);
        this.unset('comments');

        // clone collection
        this.users            = new ph.api.collections.Users(ph.api.users);
        this.users.comparator = function (model) {
            return model.get('assigned') ? 0 : 1
        };
        this.users.sort();

        // set assigned model
        if (this.get('assigned')) {
            var user = this.users.get(this.get('assigned'));
            user && this.set('assigned_model', user.attributes);
        }

        this.permissions();
        
        // set the correct order on init
        this.trigger('setOrder', this);

        this.updateComment();
        this.listenTo(this.comments, 'add', this.updateComment);
        this.listenTo(this.comments, 'remove', this.updateComment);
        this.listenTo(this.comments, 'change', this.updateComment);

        // dynamic comment count
        this.updateCount();
        this.listenTo(this.comments, 'add', this.updateCount);
        this.listenTo(this.comments, 'remove', this.updateCount);

        this.listenTo(this.users, 'assign', this.assign);
        this.listenTo(this.users, 'unAssign', this.unAssign);

        this.selectedUser();
        this.listenTo(this, 'change:assigned', this.selectedUser);
        this.listenTo(this, 'submit', this.submit);

        this.listenTo(ph.api.Event, 'live_update_thread', this.handleUpdate);
    },

    handleUpdate: function(id, action) {
        if ( id !== this.id ) {
            return false;
        }

        switch( action ) {
            case 'fetch':
                this.fetch({
                    reset: true,
                    success: function (model, response, options) {
                        console.log(arguments);
                    },
                    error: function (model, response, options) {
                        console.error(arguments);
                    }
                });
                break;
        }
    },

    permissions: function() {
        var canEdit = 'edit_others_phw_comment_loc' in ph.api.me.get('capabilities') ? ph.api.me.get('capabilities').edit_others_phw_comment_loc : false,
            canDelete = 'delete_others_phw_comment_loc' in ph.api.me.get('capabilities') ? ph.api.me.get('capabilities').delete_others_phw_comment_loc: false;

        this.set({
            'canEdit': canEdit, // || this.get('author') === ph.api.me.get('id'),
            'canDelete': canDelete
        });
    },

    submit: function(model) {
        if ( ! model.get('parent_id') ) {
            return false;
        }
        if ( model.isNew() ) {
            model.save({
                content: model.get('formContent'),
                slug   : model.get('id'),
                status : 'publish',
                title  : model.get('formContent'),
                author : ph.api.me ? ph.api.me.get('id') : 0
            },{ success: this.createComment });

            PH_Website_Settings.debug && console.log('New Thread:', model); // debug
        } else {
            this.createComment(model);
        }
    },

    createComment: function (model) {
        if (typeof model === 'undefined' ) {
            model = this.model;
        }
        var comment = model.comments.create({
            'author_name'       : ph.api.me.get('name'),
            'content'           : model.get('formContent') ? model.get('formContent') : model.get('title'),
            'post'              : model.get('id'),
            'author'            : ph.api.me.get('id'),
            'author_avatar_urls': ph.api.me.get('avatar_urls')
        });

        PH_Website_Settings.debug && console.log('New Comment:', comment); // debug
    },

    /**
     * Make first comment the title
     */
    updateComment: function () {
        if (!this.comments.length) return;

        var first = this.comments.first();
        this.set({
            'humanDate': _.timeSince(this.get('date')),
            'author_name': first.get('author_name'),
            'author_avatar_urls': first.get('author_avatar_urls'),
            'content': {
                'rendered': typeof first.get('content') !== 'undefined' ? first.get('content').rendered : ''
            }
        });
    },

    /**
     * Update item count in model
     */
    updateCount: function () {
        this.set('comment_count', this.comments.length);
    },

    // set/save assignment
    assign: function (model) {
        var method = this.isNew() ? 'set' : 'save';
        this[method]({
            'assigned'      : model.get('id'),
            'assigned_model': model.attributes
        }, {
            patch: true
        });
    },

    // save unassignment
    unAssign: function () {
        var method = this.isNew() ? 'set' : 'save';
        this[method]({
            'assigned'      : 0,
            'assigned_model': {}
        }, {
            patch: true
        });
    },

    // set assigned user in sub collection
    selectedUser: function () {
        this.users.invoke('set', {assigned: false});
        this.assigned = this.users.get(this.get('assigned'));
        this.assigned && this.assigned.set({
            assigned: true
        });
    }
});
/**
 * Website model
 * Stores entire website project
 */
ph.api.models.Website = wp.api.models.Website.extend({
    // extend defaults
    defaults: _.extend({}, wp.api.models.Website.prototype.defaults, {
        filter : 'all'
    }),

    pages: {},

    initialize: function (attributes, options) {
        wp.api.models.Website.prototype.initialize.call(this, attributes, options);

        // all pages
        this.pages = new ph.api.collections.WebsitePage(this.get('pages') || []);
        this.unset('pages');

        this.listenTo(this, 'change:filter', this.updatePages );

        this.listenTo(this.pages, 'sorted', this.updateOrder);

        this.orderPages();
    },

    updatePages: function (model) {
        this.pages.invoke('set', {'filter': model.get('filter')});
    },

    /**
     * Sort using user order
     * Based on http://stackoverflow.com/questions/13304543/javascript-sort-array-based-on-another-array
     */
    orderPages: function () {
        if (!this.get('user_order')) {
            return;
        }
        var order = _.compact(_.map(this.get('user_order'), function (i) {
            return typeof this.pages.get(i) !== 'undefined' && this.pages.get(i);
        }, this));
        this.pages.models = _.union(order, this.pages.models);
    },

    updateOrder: function (model, position) {
        this.pages.remove(model);

        this.pages.each(function (model, index) {
            var ordinal = index;
            if (index >= position) {
                ordinal += 1;
            }
            model.set('ordinal', ordinal);
        });

        model.set('ordinal', position);
        this.pages.add(model, {at: position});
        var ids = this.pages.pluck('id');

        jQuery.ajax({
            type: "POST",
            data: {
                ids: ids,
                user_id: ph.api.me.get('id')
            },
            beforeSend: function ( xhr ) {
                xhr.setRequestHeader('X-WP-Nonce', PH.nonce);
            },
            url: ph.api.url + 'website/page/reorder/' + this.get('id')
        });
    }
});
ph.api.collections.CommentFilters = Backbone.Collection.extend({
    model: ph.api.models.CommentFilter
});
ph.api.collections.Users = wp.api.collections.Users.extend({
    model: ph.api.models.User
});
ph.api.collections.Comments = wp.api.collections.Comments.extend({
    model: ph.api.models.Comment
});
ph.api.collections.WebsitePage = wp.api.collections.WebsitePage.extend({
    model: ph.api.models.WebsitePage
});
/**
 * Website Threads
 */
ph.api.collections.WebsiteThread = wp.api.collections.WebsiteThread.extend({
    model: ph.api.models.WebsiteThread,

    initialize: function( models, options ) {
        wp.api.collections.WebsiteThread.prototype.initialize.apply( models, options );
    },

    // filter
    filter_all: function () {
        return this;
    },

    filter_mine: function () {
        if ( ! ph.api.me ) {
            return this;
        }
        return new ph.api.collections.WebsiteThread(_.filter(this.models, function (thread) {
            return parseInt(thread.get('assigned')) === parseInt(ph.api.me.get('id'));
        }));
    },

    filter_unassigned: function () {
        return new ph.api.collections.WebsiteThread(_.filter(this.models, function (thread) {
            return !thread.get('assigned');
        }));
    }
});
/**
 * Avatar View
 *
 * @since 1.0
 */
ph.api.views.Avatar = ph.api.View.extend({
    template : wp.template('avatar'),
    className: 'ph-avatar'
});
/**
 * Comment Filter View
 *
 * @since 1.0
 */
ph.api.views.CommentFilter = ph.api.View.extend({
    template : wp.template('comment-switcher'),
    className: 'comment-switcher-dropdown-wrap',

    triggers: {
        'change:filter': ['render', 'hide']
    },

    events: {
        'click .ph-show-all-comments'       : 'all',
        'click .ph-show-my-comments'        : 'mine',
        'click .ph-show-unassigned-comments': 'unassigned',
        'mouseenter'                        : 'show',
        'mouseleave'                        : 'hide'
    },

    all: function () {
        this.model.set('filter', 'all');
    },

    mine: function () {
        this.model.set('filter', 'mine');
    },

    unassigned: function () {
        this.model.set('filter', 'unassigned');
    },

    show: function () {
        this.$el.addClass('ph-show');
    },

    hide: function () {
        this.$el.removeClass('ph-show');
    }
});
/**
 * View to show our comment form
 *
 * @since 1.0
 */
ph.api.views.CommentForm = ph.api.View.extend({
    className: 'comment-textarea',
    tagName: 'div',

    events: {
        "keydown .ql-editor": "keyDownHandler",
        "focus .ql-editor": "textAreaFocus"
    },

    /**
     * Model trigger handlers
     */
    triggers: {
        'resetTextArea': 'resetTextArea',
        'focusTextArea': [
            'enableTextArea',
            'resetTextArea',
            'focusTextArea'
        ],
        'change:controls': 'focusClass',
        'change:focus': 'focusHandler'
    },

    initialize: function () {
        this.listenTo(this.model.comments, 'add', this.resetTextArea);
    },

    ready: function () {
        this.setQuill();
    },

    setQuill: function () {
        this.quill = new Quill(this.$el.get(0), {
            modules: {toolbar: ph.api.editor.editorOptions},
            formats: this.editorFormats,
            placeholder:  PH.translations.comment_placeholder || 'Leave a Comment',
            theme  : 'bubble',
            bounds : this.el
        });
        phSite.autoLinkHighlight(this.quill);
        phSite.setLinkPlaceholder(this.quill);

        // on text-change
        this.quill.on('text-change', _.bind(this.contentChangedHandler, this));
    },

    textAreaFocus: function () {
        this.model.set('controls', 'true');
    },

    focusClass: function () {
        this.$el.toggleClass('focus', this.model.get('controls'));
    },

    disableTextArea: function () {
        this.quill.disable();
    },

    enableTextArea: function () {
        this.quill.enable();
    },

    focusTextArea: function () {
        this.quill.focus();
    },

    resetTextArea: function () {
        console.log('reset');
        this.quill.setContents([{insert: '\n'}]);
        this.model.set('comment_content', this.$('.ql-editor').html());
        this.$('.ql-tooltip').addClass('ql-hidden'); // manually hide
    },

    keyDownHandler: function (e) {
        if (e.shiftKey && e.keyCode == 13) { // shift + enter
            e.preventDefault();
            this.model.trigger('submitComment');
        }
    },

    contentChangedHandler: function (delta, oldDelta, source) {
        this.model.set('comment_content', this.$('.ql-editor').html());
    },

    focusHandler: function () {
        this.model.get('focus') && this.quill.focus();
    }
});
/**
 * View to show our comment button
 *
 * @since 1.0
 */
ph.api.views.CommentSubmitButton = ph.api.View.extend({
    template : wp.template('submit-new-comment'),
    className: 'button button-primary button-large',
    tagName  : 'button',

    events: {
        'click': 'buttonClickHandler'
    },

    /**
     * Model trigger handlers
     */
    triggers: {
        'change:controls': 'showHide'
    },

    /**
     * Handle Button Click
     */
    buttonClickHandler: function (e) {
        e.preventDefault();
        if (!this.model.get('comment_content') || this.model.get('comment_content') === '<p><br></p>') {
            return false;
        }
        this.createItem();
        return false;
    },

    createItem: function () {
        this.model.comments.create({
            'author_name'       : ph.api.me.get('name'),
            'content'           : this.model.get('comment_content'),
            'post'              : this.model.get('id'),
            'author'            : ph.api.me.get('id'),
            'author_avatar_urls': ph.api.me.get('avatar_urls')
        });
        this.model.set('comment_content', '');
    },

    showHide: function () {
        if (!this.model.get('controls')) {
            this.$el.hide();
        } else {
            this.$el.show();
        }
    }
});

/**
 * View to show our individual comment item
 *
 * @since 1.0
 */
ph.api.views.Comment = ph.api.View.extend({
    template : wp.template('info-comment-item'),
    className: 'ph-comment',

    events: {
        'click .ph-remove': 'removeComment',
        'click .ph-edit'  : 'editComment'
    },

    initialize: function () {
        // comment item text view
        this.views.set('.ph-comment-item-text', new ph.api.views.CommentItemText({
            model: this.model
        }));

        // edit comment form
        this.views.set('.ph-edit-textarea', new ph.api.views.CommentEditForm({
            model: this.model
        }));

        // comment item text view
        if (this.model.get('author') === ph.api.me.get('id')) {
            this.views.set('.ph-item-controls', new ph.api.views.CommentItemControls({
                model: this.model
            }));
        }
    },

    /**
     * Remove comment click handler - let the collection handle itself
     */
    removeComment: function (e) {
        e.preventDefault();
        confirm("Are you sure?") && this.destroyComment();
    },

    /**
     * Shows the edit textbox, focuses and places cursor at end
     */
    editComment: function () {
        this.model.set('edit', true);
    },

    /**
     * Animate removal
     */
    destroyComment: function () {
        this.$el.slideToggle(250, _.bind(function () {
            this.remove();
            this.unbind();
            this.model.destroy();
        }, this));
    }
});

/**
 * View to show our individual comment item text
 *
 * @since 1.0
 */
ph.api.views.CommentItemText = ph.api.View.extend({
    template : wp.template('comment-item-text'),
    className: 'comment-item-text',

    triggers: {
        'change:content': 'render',
        'change:edit'   : ['showHide', 'render']
    },

    showHide: function () {
        this.$el.toggle(!this.model.get('edit'));
    }
});

/**
 * View to show our individual comment item edit box
 *
 * @since 1.0
 */
ph.api.views.CommentEditForm = ph.api.View.extend({
    template : wp.template('edit-comment-form'),
    className: 'ph-edit-form',

    events: {
        'click .ph-edit-cancel'      : 'cancelEdit',
        'click .ph-edit-save:enabled': 'updateComment'
    },

    triggers: {
        'change:edit': ['toggleEdit', 'setQuill'],
        'change:content': ['render']
    },

    ready: function () {
        this.toggleEdit();
    },

    setQuill: function () {
        this.quill = new Quill(this.$('.ph-edit-content').get(0), {
            modules: {toolbar: ph.api.editor.editorOptions},
            formats: this.editorFormats,
            theme  : 'bubble',
            bounds : this.el
        });
        phSite.autoLinkHighlight(this.quill);
        phSite.setLinkPlaceholder(this.quill);
    },

    toggleEdit: function () {
        this.$el.toggle(this.model.get('edit'));
    },

    cancelEdit: function () {
        this.model.set('edit', false);
        return false;
    },

    updateComment: function () {
        this.model.save({
            'content': this.$('.ql-editor').html(),
            'edit'           : false // done editing
        });
        return false;
    }
});

/**
 * View to show our individual comment item text
 *
 * @since 1.0
 */
ph.api.views.CommentItemControls = ph.api.View.extend({
    template : wp.template('comment-item-controls'),
    className: 'comment-item-controls-inner',

    initialize: function () {
        this.listenTo(this.model, 'change:edit', this.showHide);
    },

    showHide: function () {
        this.$el.toggle(!this.model.get('edit'));
    }
});
/**
 * Members view
 *
 * @since 2.6.0
 */
ph.api.views.Members = ph.api.View.extend({
    events: {
        'select2:select'  : 'members',
        'select2:unselect': 'members'
    },

    initialize: function () {
        this.setElement(this.el);
        this.render();
        _.bindAll(this, 'members');
    },

    /**
     * Ajax members select2
     *
     * @param e
     */
    members: function (e) {
        // normalize data
        var data = typeof e.params.data === 'undefined' ? e.params : e.params.data;

        // update via ajax
        jQuery.ajax({
            type      : data.selected ? "POST" : "DELETE", // post if selected, delete if unselected
            data      : {
                email: data.id // email
            },
            beforeSend: function (xhr) {
                xhr.setRequestHeader('X-WP-Nonce', wpApiSettings.nonce);
            },
            url       : ph.api.url + 'website/project/' + this.model.get('id') + '/actions/subscribe'
        });
    }
});
/**
 * Avatar View
 *
 * @since 1.0
 */
ph.api.views.Notifications = ph.api.View.extend({
    events: {
        'change #ph_project_email_notifications_disable_all': 'toggle'
    },

    initialize: function () {
        this.setElement(this.el);
        this.render();
        _.bindAll(this, 'email');
    },

    toggle: function(e) {
        this.email(jQuery(e.target).prop('checked'));
    },

    /**
     * Ajax email notifications
     */
    email: function (checked) {
        // update via ajax
        jQuery.ajax({
            type      : checked ? "PUT" : "DELETE", // post if selected, delete if unselected
            beforeSend: function (xhr) {
                xhr.setRequestHeader('X-WP-Nonce', wpApiSettings.nonce);
            },
            url       : ph.api.url + 'user/suppression/email/project/' + this.model.get('id')
        });
    }
});
/**
 * Members view
 *
 * @since 2.6.0
 */
ph.api.views.Options = ph.api.View.extend({
    events: {
      'change .ph_project_access input': 'updateAccess'
    },

    initialize: function () {
        this.setElement(this.el);
        this.render();
    },

    updateAccess: function(e) {
        this.model.save({
            'project_access': e.target.value
        }, {
            patch: true
        });
    }
});

/**
 * Website list
 *
 * Subview of the panel view that shows an individual comment in a list
 *
 * @since 1.2.0
 */
ph.api.views.ResolveBox = ph.api.View.extend({
    template : wp.template('ph-resolve-check'),
    className: 'ph-resolve',
    tagName  : 'div',

    events: {
        'click': 'toggleResolve'
    },

    triggers: {
        'change:resolved': 'render'
    },

    toggleResolve: function (e) {
        this.model.save({
            'resolved': !this.model.get('resolved')
        }, {
            patch: true
        });
        return false;
    }
});
/**
 * Resolved tab view
 *
 * @since 1.0
 */
ph.api.views.ResolvedTab = ph.api.View.extend({
    template : wp.template('website-tab'),
    className: 'ph-webpage-completed-tab',

    triggers: {
        'change:resolved_count': 'render'
    }
});
/**
 * Tasks View (unresolved)
 */
ph.api.views.ResolvedThreads = ph.api.View.extend({
    template : wp.template('resolved-tasks'),
    className: 'ph-webpage-completed-tasks',

    events: {
        'click .ph-resolved-tab': 'toggleResolved'
    },

    triggers: {
        'change:filter': 'setThreads'
    },

    ready: function () {
        if (this.model.resolvedThreads().length > 1) {
            this.$('.ph-resolved-tasks').sortable({
                handle: ".ph-sort-handle",
                delay : 150,
                helper: 'clone',
                // consider using update instead of stop
                start : function (event, ui) {
                    ui.item.trigger('start', ui.item.index());
                },
                stop  : function (event, ui) {
                    ui.item.trigger('drop', ui.item.index());
                }
            });
        }
    },

    initialize: function () {
        this.views.add('.ph-resolved-tab', new ph.api.views.ResolvedTab({
            model: this.model
        }));

        this.listenTo(this.model.threads, 'change:resolved', this.setThreads);

        this.setThreads();
    },

    setThreads: function () {
        var views = [];
        this.model.resolvedThreads().forEach(function (thread) {
            views.push(new ph.api.views.Thread({
                model: thread
            }));
        }, this);

        this.views.set('.ph-resolved-tasks', views);
    },

    toggleResolved: function () {
        this.$el.toggleClass('show');
    }
});
/**
 * Avatar View
 *
 * @since 1.0
 */
ph.api.views.ShareButton = ph.api.View.extend({
	events: {
		'click': 'linkDialog'
	},

	initialize: function () {
		this.setElement(this.el);
		this.render();
		_.bindAll(this, 'linkDialog');
	},

	linkDialog: function () {
		window.prompt('Share this access link:', this.model.get('link'));
	}
});
/**
 * Avatar View
 *
 * @since 1.0
 */
ph.api.views.ThreadControls = ph.api.View.extend({
    template : wp.template('ph-thread-controls'),
    className: 'ph-webpage-controls',

    triggers: {
        'change:assigned'     : 'render',
        'change:comment_count': 'render'
    }
});
/**
 * Webpage View
 *
 * @since 1.2.0
 */
ph.api.views.ThreadInfoPanel = ph.api.View.extend({
    className: 'ph-info-inner',
    template : wp.template('thread-info-panel'),

    triggers: {
        'scrollBottom': 'scrollBottom'
    },

    initialize: function () {
        // add comments
        this.model.comments.forEach(function (item, index) {
            // skip first comment
            if (index === 0) {
                return;
            }
            // add comment
            this.addComment(item);
        }, this);

        this.views.add('.info-form', new ph.api.views.Avatar({
            model: this.model
        }));

        this.views.add('.info-form', new ph.api.views.CommentForm({
            model: this.model
        }));

        this.views.add('.info-button', new ph.api.views.CommentSubmitButton({
            model: this.model
        }));

        this.views.add('.select-users', new ph.api.views.UserSelect({
            model: this.model
        }));

        // add comment view when model is added to collection
        this.listenTo(this.model.comments, 'add', this.addComment);
        this.listenTo(this.model.comments, 'add', this.scrollBottom);
    },

    ready: function () {
        this.commentsList = this.$('.info-panel-comments-list');
    },

    addComment: function (item) {
        this.views.add('.info-panel-comments-list', new ph.api.views.Comment({
            model: item
        }));
    },

    scrollBottom: function () {
        this.commentsList.scrollTop(this.commentsList[0].scrollHeight);
    }
});
/**
 * Website list
 *
 * Subview of the panel view that shows an individual comment in a list
 *
 * @since 1.2.0
 */
ph.api.views.ThreadText = ph.api.View.extend({
    template : wp.template('ph-website-task-text'),
    className: 'ph-comment-content-inner',

    triggers: {
        'change:textOverflow': 'showHideLinks', // show more link?
        'change:showFull'    : 'showHideContent' // show or hide content?
    },

    initialize: function () {
        _.bindAll(this, 'heightHandler');
    },

    ready: function () {
        this.heightHandler();
        jQuery(window).resize(this.heightHandler);
    },

    heightHandler: function () {
        // if the scrollheight is bigger than the height
        if (this.$el.height() + 5 < this.el.scrollHeight) {
            this.model.set('textOverflow', true);
        } else {
            this.model.set('textOverflow', false);
        }
    }
});
/**
 * Top level view that orchestrates the front-end experience.
 *
 * Extends Huddle.View mixin
 *
 * this.collection holds the entire images collection and all subdata
 *
 * @since 1.0
 */
ph.api.views.Thread = ph.api.View.extend({
    template: wp.template('website-task'),
    className: 'ph-thread',

    events: {
        'click .ph-trash-thread': 'trash',
        'touchstart .ph-trash-thread': 'trash',

        'drop': 'drop',

        'click .ph-show-info': 'triggerThreadPanel',
        'click .ph-more': 'showText',
        'click .ph-less': 'hideText',

        'touchend .ph-show-info': 'triggerThreadPanel',
        'touchend .ph-more': 'showText',
        'touchend .ph-less': 'hideText'
    },

    triggers: {
        'change:showInfo': 'showThreadPanel',
        'change:textOverflow': 'showHideLinks',
        'change:showFull': 'showHideContent',
        'change:show': 'showHide'
    },

    initialize: function () {
        // checkbox
        this.views.set('.checkbox-wrap', new ph.api.views.ResolveBox({
            model: this.model
        }));

        // info panel
        this.views.set('.ph-task-info', new ph.api.views.ThreadInfoPanel({
            model: this.model
        }));

        // controls
        this.views.set('.ph-webpage-controls-wrap', new ph.api.views.ThreadControls({
            model: this.model
        }));

        // thread text
        this.views.set('.ph-comment-content', new ph.api.views.ThreadText({
            model: this.model
        }));
    },

    drop: function(event, index) {
        this.model.trigger('sorted scrollBottom', this.model, index);
    },

    trash: function (e) {
        e.preventDefault();
        confirm(PH.translations.are_you_sure) && this.destroyThread();
    },

    destroyThread: function() {
        this.$el.slideToggle(250, _.bind(function () {
            this.remove();
            this.unbind();
            this.model.destroy();
        }, this));
    },

    showText: function(e) {
        e.preventDefault();
        this.model.set('showFull', true);
    },

    hideText: function(e) {
        e.preventDefault();
        this.model.set('showFull', false);
    },

    triggerThreadPanel: function(e) {
        e.preventDefault();

        // cache model attribute
        var show = this.model.get('showInfo');

        // if hidden, show, otherwise hide
        if (show) {
            this.model.set('showInfo', false);
        } else {
            this.model.set('showInfo', true);
        }
    },

    showThreadPanel: function() {
        if ( this.model.get('showInfo') ) {
            this.$('.ph-task-info').show(0, _.bind(function(){
                this.model.trigger('scrollBottom');
            }, this));
        } else {
            this.$('.ph-task-info').hide();
        }
    },

    showHide: function() {
        this.model.get('show') ? this.$el.show() : this.$el.hide();
    },

    showHideLinks: function() {
        this.$('.ph-more').toggleClass('ph-hidden', !this.model.get('textOverflow'));
        this.$('.ph-less').toggleClass('ph-hidden', !this.model.get('textOverflow'));
    },

    showHideContent: function() {
        this.$el.toggleClass('ph-show', this.model.get('showFull'));
    },

    hidePanel: function() {
        this.model.set('showInfo', false);
    }
});
/**
 * Threads View (unresolved)
 */
ph.api.views.Threads = ph.api.View.extend({
    className: 'ph-webpage-tasks',

    triggers: {
        'change:filter': 'setThreads'
    },

    initialize: function () {
        this.listenTo(this.model.threads, 'change:resolved', this.setThreads);

        this.setThreads();
    },

    ready: function () {
        if (this.model.unresolvedThreads().length > 1) {
            this.$el.sortable({
                helper: 'clone',
                handle: ".ph-sort-handle",
                delay : 150,
                // consider using update instead of stop
                stop  : function (event, ui) {
                    ui.item.trigger('drop', ui.item.index());
                }
            });
        }
    },

    setThreads: function () {
        var views = [];
        this.model.unresolvedThreads().forEach(function (thread) {
            views.push(new ph.api.views.Thread({
                model: thread
            }));
        }, this);

        if (!this.model.filteredThreads()) {
            views.push(new ph.api.views.NoThreads({
                model: this.model
            }));
        }

        this.views.set(views);
    }
});

ph.api.views.NoThreads = ph.api.View.extend({
    template: wp.template('no-comments')
});
/**
 * Avatar View
 *
 * @since 1.0
 */
ph.api.views.Title = ph.api.View.extend({
    events    : {
        'blur': 'saveTitle'
    },
    initialize: function () {
        this.setElement(this.el);
        this.render();
    },
    saveTitle : function () {
        this.model.save({
            title: this.$el.val()
        }, {
            patch  : true,
            success: function (response) {
                window.onbeforeunload = null;
                jQuery(window).off('beforeunload.edit-post unload');
            }
        });
        window.onbeforeunload = null;
        jQuery(window).off('beforeunload.edit-post unload');
    }
});
ph.api.views.WebpageTitleEdit = ph.api.View.extend({
    template: wp.template('edit-webpage-title'),
    className: 'ph-title-edit',

    events: {
        'click .ph-edit-save:enabled': 'save'
    },

    save: function(e){
        this.$('.ph-edit-save').attr('disabled', 'disabled');
        this.model.save({
            'title': this.$('.ph-edit-content').val()
        }, {
            patch: true,
            wait: true
        });

        return false;
    }
});
ph.api.views.WebpageTitle = ph.api.View.extend({
    template: wp.template('webpage-title'),
    className: 'ph-title-edit',

    events: {
        'click .ph-edit-title': 'editTitle',
        'click .ph-edit-cancel': 'removeEdit'
    },

    triggers: {
        'change:title': ['removeEdit', 'render']
    },

    editTitle: function() {
        this.$el.addClass('ph-editing');
        this.views.set('.ph-website-title-edit', new ph.api.views.WebpageTitleEdit({
            model: this.model
        }));

        return false;
    },

    removeEdit: function() {
        this.$el.removeClass('ph-editing');
        this.views.remove('.ph-website-title-edit');

        return false;
    }
});
/**
 * Webpage View
 *
 * @since 1.2.0
 */
ph.api.views.Webpage = ph.api.View.extend({
    template: wp.template('website-page'),
    className: 'ph-webpage',

    triggers: {
        'change:empty': 'render'
    },

    events: {
        'click .ph-toggle-page': 'toggleHeight',
        'dropped'              : 'drop',
        'click .ph-trash-page' : 'trash'
    },

    initialize: function () {
        // title
        this.views.add('.ph-webpage-title', new ph.api.views.WebpageTitle({
            model: this.model
        }));

        // threads
        this.views.add('.ph-webpage-tasks-container', new ph.api.views.Threads({
            model: this.model
        }));
        this.views.add('.ph-webpage-tasks-container', new ph.api.views.ResolvedThreads({
            model: this.model
        }));

        this.listenTo(this.model.threads, 'remove', this.removeIfEmpty);
    },

    drop: function (event, index) {
        this.model.trigger('sorted', this.model, index);
    },

    maybeNone: function () {
        if (this.model.threads.where({show: true}).length) {
            this.model.set('empty', false);
        } else {
            this.model.set('empty', true);
        }
    },

    removeIfEmpty: function () {
        if ( this.model.threads.length == 0 ) {
            this.remove();
        }
    },

    toggleHeight: function(e) {
        this.$el.toggleClass('closed');
        e.preventDefault();
    },

    trash: function() {
        var confirm = window.confirm(PH.translations.are_you_sure);

        if (confirm === true) {
            this.model.destroy();
            this.remove();
        }
    }
});
/**
 * Avatar View
 *
 * @since 1.0
 */
ph.api.views.WebsiteTitle = ph.api.View.extend({
    events: {
        'blur': 'saveTitle'
    },
    initialize: function () {
        this.setElement(this.el);
        this.render();
    },
    saveTitle: function () {
        this.model.save({
            title: this.$el.val()
        }, {
            patch: true,
            success: function(response) {
                window.onbeforeunload = null;
                jQuery(window).off( 'beforeunload.edit-post unload' );
            }
        });
        window.onbeforeunload = null;
        jQuery(window).off( 'beforeunload.edit-post unload' );
    }
});
/**
 * Webpage View
 *
 * @since 1.2.0
 */
ph.api.views.UserSelect = ph.api.View.extend({
    className: 'ph-select-users',
    template : wp.template('user-select'),
    tagName  : 'select',

    initialize: function () {
        _.bindAll(this, 'assign', 'unassign');
    },

    ready: function () {
        this.select2Start();
        this.$el.on("select2:select", this.assign);
        this.$el.on('select2:unselect', this.unassign);
    },

    /**
     * Sets model assignment and saves
     * @param e
     */
    assign: function (e) {
        var data = typeof e.params.data === 'undefined' ? e.params : e.params.data;

        this.model.save({
            'assigned'      : data.id,
            'assigned_model': data.model
        }, {
            patch: true
        });
    },

    /**
     * Sets model unassignment and saves
     */
    unassign: function () {
        this.model.save({
            'assigned'      : 0,
            'assigned_model': []
        }, {
            patch: true
        });
    },

    /**
     * Initializes Select2
     */
    select2Start: function () {
        this.$el.select2({
            placeholder       : 'Select A User',
            data              : phSite.users,
            allowClear        : true,
            ajax              : {
                url           : wpApiSettings.root + wpApiSettings.versionString + "users",
                method        : "GET",
                delay         : 250,
                data          : function (params) {
                    return {
                        search: params.term // search term
                    };
                },
                processResults: function (data, params) {
                    // parse the results into the format expected by Select2
                    var results = [];
                    _.each(data, function (value, key, list) {
                        var obj = {
                            id    : value.id,
                            avatar: value.avatar_urls['24'],
                            text  : value.name,
                            model : value
                        };
                        results.push(obj);
                    });

                    return {
                        results: results
                    };
                },
                cache         : true
            },
            minimumInputLength: 0,
            templateResult    : formatAvatar,
            templateSelection : formatAvatar
        });

        // Add avatar to select
        function formatAvatar(user) {
            if (user.text.length == 0) {
                return false;
            }
            if (!user.avatar) {
                if ( typeof user.element !== 'undefined') {
                    var $user = jQuery(
                        '<span class="select-avatar"><img src="' + user.element.dataset.avatar + '" class="avatar"> <span>' + user.text + '</span></span>'
                    );
                    return $user;
                }
                return user.text;
            }
            var $user = jQuery(
                '<span class="select-avatar"><img src="' + user.avatar + '" class="avatar"> <span>' + user.text + '</span></span>'
            );
            return $user;
        }
    }
});
/**
 * Top level view that orchestrates the front-end experience.
 *
 * Extends Huddle.View mixin
 *
 * this.collection holds the entire images collection and all subdata
 *
 * @since 1.0
 */
ph.api.views.Website = ph.api.View.extend({
    template: wp.template('website-container'),
    className: "website-inner",

    initialize: function () {
        // views
        this.model.pages.forEach(function (item) {
            this.views.add('.ph-webpages', new ph.api.views.Webpage({
                model: item
            }));
        }, this);

        this.views.add('.comment-switcher-dropdown-container', new ph.api.views.CommentFilter({
            model: this.model
        }));

        // add titlebox
        this.titleBox = new ph.api.views.WebsiteTitle({
            el:  jQuery("#titlewrap #title"),
            model: this.model
        });

        // add members
        this.members = new ph.api.views.Members({
            el:  jQuery(".ph-select2.ph-get-users"),
            model: this.model
        });

        // project options
        this.options = new ph.api.views.Options({
            el:  jQuery("#ph-website-project-options"),
            model: this.model
        });

        // add notifications
        this.notifications = new ph.api.views.Notifications({
            el:  jQuery("#project_emails_notifications_container"),
            model: this.model
        });

		this.copyLink = new Clipboard('.ph-copy-link');

		this.copyLink.on('success', function(e) {
			alert(PH.translations.copied);
		});
    },

    /**
     * Make sortable
     */
    ready: function () {
        this.$('.ph-webpages').sortable({
            helper : 'clone',
            delay: 150,
            handle: ".ph-webpage-title",
            // consider using update instead of stop
            stop: function (event, ui) {
                ui.item.trigger('dropped', ui.item.index());
            }
        });
    }
});
/**
 * Setup page events and collections
 *
 * @package     ProjectHuddle
 * @subpackage  js
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */

(function($){

    // use strict mode
    'use strict';

    /**
     * Setup Page
     *
     * @since 1.0
     */
    $(document).ready(function(){
        // tabs
		$('.nav-tab-wrapper a').click(function(e){
			var $this = $(this),
				current = $this.data('value');

			// change input
			$this.parent().find('input').val($this.data('value'));

			// class change
			$('.nav-tab-active').removeClass('nav-tab-active');
			$this.addClass('nav-tab-active');

			$('.ph-tab-content').hide();
			$('.show-' + current ).show();

			e.preventDefault();
		});

		// find active tab
		var current = $('.nav-tab-active').data('value');

		$('.ph-tab-content').hide();
		$('.show-' + current ).show();
	});

}(jQuery));