<?php
/**
 * Template for the individual task item on admin
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */
?>

<!-- Website -->
<script type="text/template" id="tmpl-website-container">
	<div class="comment-switcher-dropdown-container"></div>
	<div class="ph-view-website-link">
		<a href="{{{ data.link }}}">View Website <i class="ion-arrow-right-c"></i></a>
	</div>
	<div class="ph-webpages">
		<p class="ph-placeholder ph-webpage-placeholder"><?php _e('No comments!', 'project-huddle'); ?></p>
	</div>
</script>

<script type="text/template" id="tmpl-no-comments">
	<span class="ph-placeholder"><?php _e( 'No Comments.', 'project-huddle' ); ?></span>
</script>

<script type="text/template" id="tmpl-comment-switcher">
	<h4 class="comment-switcher-dropdown">
		<# if (data.filter == 'unassigned') { #>
			<?php _e( 'Unassigned', 'project-huddle' ); ?>
		<# } else if ( data.filter == 'mine' ) { #>
			<?php _e( 'Assigned To Me', 'project-huddle' ); ?>
		<# } else { #>
			<?php _e( 'All Comments', 'project-huddle' ); ?>
		<# } #><i class="ion-chevron-down"></i></h4>
	<div class="comment-switcher-menu-wrap">
		<ul class="comment-switcher-menu">
			<li class="ph-show-all-comments <# if (data.filter== 'all') { print('active'); } #>"><?php _e( 'All Comments', 'project-huddle' ); ?></li>
			<li class="ph-show-my-comments <# if (data.filter== 'mine') { print('active'); } #>"><?php _e( 'Assigned To Me', 'project-huddle' ); ?></li>
			<li class="ph-show-unassigned-comments <# if (data.filter== 'unassigned') { print('active'); } #>"><?php _e( 'Unassigned', 'project-huddle' ); ?></li>
		</ul>
	</div>
</script>

<script type="text/html" id="tmpl-webpage-title">
	<span class="ph-website-title-rendered title-link">
		{{{ data.title.rendered }}}
		<span class="ion-edit ph-edit-title"></span>
		<a href="{{{ data.page_url }}}" target="_blank">
			<span class="ion-location"></span>
		</a>
		<span class="ion-trash-a ph-trash-page"></span>
	</span>
	<div class="ph-website-title-edit"></div>
</script>

<script type="text/html" id="tmpl-edit-webpage-title">
	<input class="ph-edit-content" value="{{{ data.title.rendered }}}" /><br>
	<button class="button button-primary ph-edit-save"><?php _e( 'Save', 'project-huddle' ); ?></button>
	<button class="button button-secondary ph-edit-cancel"><?php _e( 'Cancel', 'project-huddle' ); ?></button>
</script>

<!-- Webpage Section Template -->
<script type="text/template" id="tmpl-website-page">
	<div class="ph-webpage-header">
	<h4 class="ph-webpage-title"></h4>
	<a href="#" class="ph-toggle-indicator ph-toggle-page">
		<span class="ion-minus"></span>
		<span class="ion-plus"></span>
	</a>
	</div>
	<div class="ph-webpage-tasks-container"></div>
	<div class="ph-comment-counter ph-placeholder ph-toggle-page"><span>{{ data.comment_count }} <?php _e('Comments', 'project-huddle');?></span></div>
</script>

<!-- Comment Box Template -->
<script type="text/template" id="tmpl-website-task">
	<div class="todo-item ph-sort-handle <# if ( data.showInfo ) { print( 'opened' ); } #>">
		<div class="checkbox-wrap"></div>
		<div class="checkbox-text">
			<div class="ph-checkbox-header">
				<div class="ph-info ph-show-info">
					<div class="ph-comment-author">
						{{ data.author_name }}
					</div>
					<div class="ph-comment-date">
						{{ data.humanDate }}
					</div>
				</div>
				<div class="ph-webpage-controls-wrap"></div>
			</div>

			<div class="ph-comment-content"></div>
			<a href="#" class="ph-more ph-hidden">More</a>
			<a href="#" class="ph-less ph-hidden">Less</a>

		</div>
	</div>
	<div class="ph-task-info ph-hidden"></div>
</script>

<script type="text/template" id="tmpl-ph-website-task-text">
	<# if ( data.content ) {  #>
		{{{ data.content.rendered }}}
	<# } #>
</script>

<script type="text/template" id="tmpl-ph-thread-controls">
	<# if ( data.assigned ) {  #>
		<div class="ph-tooltip-wrap ph-assigned ph-show-info">
			<img src="{{{ data.assigned_model.avatar_urls[96] }}}" class="avatar" />
			<div class="ph-tooltip">
				<?php _e( 'Assigned To', 'project-huddle' ); ?> {{{ data.assigned_model.name }}}
			</div>
		</div>
	<# } #>
	<div class="ph-tooltip-wrap ph-show-info ph-comment-count-icon">
		<i class="ion-chatbox"></i>
		<span class="ph-comment-count">{{ data.comment_count - 1 }}</span>
		<div class="ph-tooltip">
			{{ data.comment_count - 1 }} <?php _e( 'Comments', 'project-huddle' ); ?>
		</div>
	</div>
		<a href="{{{ data.link }}}"  target="_blank" class="ph-tooltip-wrap">
			<i class="ion-location"></i>
			<span class="ph-tooltip">View Location <i class="ion-android-open"></i></span>
		</a>
	<div class="ph-tooltip-wrap ph-show-info ph-more-toggle">
		<div class="ion-android-more-vertical"></div>
		<div class="ph-tooltip">
			<?php _e( 'Details & Replies', 'project-huddle' ); ?>
		</div>
	</div>
</script>

<script type="text/template" id="tmpl-ph-resolve-check">
	<i class="ph-icon ph-loading"></i>
	<# if (!data.resolved ) { #>
		<i class="ph-icon checkbox ion-android-checkbox-outline-blank"></i>
	<# } else { #>
		<i class="ph-icon checkbox ion-android-checkbox ph-approved"></i>
	<# } #>
</script>

<!-- Website -->
<script type="text/template" id="tmpl-thread-info-panel">
	<div class="info-panel-details">
		<div class="detail detail-location">
			<span class="detail-title">
				<?php _e( 'Location', 'project-huddle' ); ?>
			</span>
			<span class="detail-value">
				<a href="{{{ data.link }}}">
					<i class="ion-location"></i>
					{{ data.page_url }}
				</a>
			</span>
		</div>
		<div class="detail detail-assigned">
			<span class="detail-title">
				<?php _e( 'Assigned', 'project-huddle' ); ?>
			</span>

			<span class="detail-value select-users"></span>
		</div>

		<# if (data.browser) { #>
			<div class="detail detail-browser">
				<span class="detail-title">
					<?php _e( 'Browser', 'project-huddle' ); ?>
				</span>
				<span class="detail-value">
					{{ data.browser }} {{ data.browserVersion }}
				</span>
			</div>
		<# } #>

		<div class="detail detail-browser-size">
			<span class="detail-title">
				<?php _e( 'Browser Size', 'project-huddle' ); ?>
			</span>
			<span class="detail-value">
				{{ data.resX }} x {{ data.resY }}
			</span>
		</div>

		<# if (data.browserOS) { #>
			<div class="detail detail-browser-os">
				<span class="detail-title">
					<?php _e( 'OS', 'project-huddle' ); ?>
				</span>
					<span class="detail-value">
					{{ data.browserOS }}
				</span>
			</div>
		<# } #>

		<div class="detail detail-share-link">
			<span class="detail-title">
				<?php _e( 'Share Link', 'project-huddle' ); ?>
			</span>
			<span class="detail-value">
				<a href="{{{ data.link }}}" onClick="prompt('<?php _e('Copy this shareable link:', 'project-huddle'); ?>', '{{{ data.link }}}'); return false;">
					<i class="ion-android-clipboard"></i>
					<?php _e('Copy', 'project-huddle'); ?>
				</a>
			</span>
		</div>

		<a href="#" class="ph-tooltip-wrap ph-trash-thread">
			<i class="ion-trash-a"></i>
			<?php _e( 'Trash', 'project-huddle' ); ?>
		</a>
	</div>
	<div class="info-panel-comments">
		<div class="info-panel-header">
			<h4>
				<?php _e( 'Comments', 'project-huddle' ); ?>
			</h4>
		</div>
		<div class="info-panel-comments-list">
			<# if (!data.comment_count) { #>
				<span class="ph-placeholder">
					<?php _e( 'No replies yet!', 'project-huddle' ); ?>
				</span>
			<# } #>
		</div>
		<div class="info-panel-controls">
			<div class="info-form"></div>
			<div class="info-button"></div>
		</div>
	</div>
</script>

<script type="text/template" id="tmpl-user-select">
	<# if ( data.assigned != 0 ) {  #>
		<option value="{{ data.assigned }}" selected="selected" data-avatar="{{ data.assigned_model.avatar_urls[24] }}"><span>{{ data.assigned_model.name }}</span></option>
	<# } #>
</script>

<script type="text/template" id="tmpl-avatar">
	<?php
	$current_user = wp_get_current_user();
	echo get_avatar( $current_user->ID, 48 );
	?>
</script>

<script type="text/template" id="tmpl-submit-new-comment">
	<?php _e( 'Add Comment', 'project-huddle' ); ?>
</script>


<!-- Comment Item Template -->
<script type="text/template" id="tmpl-info-comment-item">

    <div class="ph-avatar">
        <img src="{{{ data.author_avatar_urls[96] }}}" class="avatar" />
    </div>

    <span class="ph-info-wrapper">
        <span class="ph-item-controls"></span>

        <span class="ph-info">
            <span class="ph-comment-author">
                {{ data.author_name }}
            </span>

            <span class="ph-comment-date">
                {{ data.humanDate }}
            </span>
        </span>
        <span class="ph-comment-item-text ph-comment-content-single"></span>
        <span class="ph-edit-textarea"></span>
    </span>
</script>
<!-- Comment Item Template -->

<script type="text/html" id="tmpl-edit-comment-form">
    <div class="ph-edit-content">
		{{{ data.content.rendered }}}
	</div>
    <button class="button button-primary ph-edit-save"><?php _e( 'Save', 'project-huddle' ); ?></button>
    <button class="button button-secondary ph-edit-cancel"><?php _e( 'Cancel', 'project-huddle' ); ?></button>
</script>

<script type="text/html" id="tmpl-comment-item-text">
    <div class="ph-comment-item-content">
		<# if ( data.content.rendered ) { #>
			{{{ data.content.rendered }}}
		<# } else { #>
		    {{{ data.content }}}
		<# } #>
    </div>
</script>

<script type="text/html" id="tmpl-comment-item-controls">
    <i class="ph-icon ph-edit ion-android-create"></i>
    <i class="ph-icon ph-remove ion-trash-b" data-confirm="<?php _e('Are you sure you want to delete this comment?', 'project-huddle' ); ?>"></i>
</script>

<script type="text/template" id="tmpl-resolved-tasks">
	<div class="ph-resolved-tab"></div>
	<div class="ph-resolved-tasks"></div>
</script>

<script type="text/template" id="tmpl-website-tab">
	<# if ( data.resolved_count ) { #>
		{{ data.resolved_count }} <?php _e( 'Resolved Threads', 'project-huddle' ); ?> <span class="ion-chevron-right"></span>
	<# } #>
</script>

<script type="text/template" id="tmpl-all-done">
	<?php _e( 'All threads resolved.', 'project-huddle' ); ?>
</script>

<!-- Application data -->
<script>
	jQuery(document).ready(function () {
		ph.api.start(<?php echo json_encode( $project_data ); ?>);
	});
</script>