<?php
/**
 * Template for the individual project image thumbnail
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */
?>

<script type="text/template" id="tmpl-avatar">
    <img src="{{{ data.author_avatar_urls[96] }}}" class="gravatar avatar"/>
</script>

<!-- Comment Item Template -->
<script type="text/template" id="tmpl-project-comment-item">
    <div class="ph-avatar"></div>

    <div class="ph-item-controls"></div>

    <div class="ph-comment-wrap">
        <div class="ph-comment-item-author">
            {{ data.author_name }}
        </div>

        <div class="ph-comment-item-date">
            {{ data.humanDate }}
        </div>
        <div class="ph-comment-item-text"></div>
        <div class="ph-edit-textarea"></div>
    </div>
</script>
<!-- Comment Item Template -->

<script type="text/html" id="tmpl-edit-comment-form">
    <div class="ph-edit-content">
        <# if ( data.content.rendered ) { #>
            {{{ data.content.rendered }}}
        <# } else { #>
            {{{ data.content }}}
        <# } #>
    </div>
    <button class="ph-button ph-edit-save"><?php _e( 'Save', 'project-huddle' ); ?></button>
    <button class="ph-secondary-link ph-edit-cancel"><?php _e( 'Cancel', 'project-huddle' ); ?></button>
</script>

<script type="text/html" id="tmpl-comment-item-text">
    <div class="ph-comment-item-content">
        <# if ( data.content.rendered ) { #>
            {{{ data.content.rendered }}}
        <# } else { #>
            {{{ data.content }}}
        <# } #>
    </div>
</script>

<script type="text/html" id="tmpl-comment-item-controls">
    <i class="ph-icon ph-edit ion-android-create">
        <svg viewBox="0 0 512 512" id="ion-android-create" width="14" height="14"><path d="M64 368v80h80l235.727-235.729-79.999-79.998L64 368zm377.602-217.602c8.531-8.531 8.531-21.334 0-29.865l-50.135-50.135c-8.531-8.531-21.334-8.531-29.865 0l-39.468 39.469 79.999 79.998 39.469-39.467z"></path></svg>
    </i>
    <i class="ph-icon ph-remove ion-trash-b" data-confirm="<?php _e('Are you sure you want to delete this comment?', 'project-huddle' ); ?>">
        <svg viewBox="0 0 512 512" id="ion-trash-b" width="14" height="14"><path d="M413.7 133.4c-2.4-9-4-14-4-14-2.6-9.3-9.2-9.3-19-10.9l-53.1-6.7c-6.6-1.1-6.6-1.1-9.2-6.8-8.7-19.6-11.4-31-20.9-31h-103c-9.5 0-12.1 11.4-20.8 31.1-2.6 5.6-2.6 5.6-9.2 6.8l-53.2 6.7c-9.7 1.6-16.7 2.5-19.3 11.8 0 0-1.2 4.1-3.7 13-3.2 11.9-4.5 10.6 6.5 10.6h302.4c11 .1 9.8 1.3 6.5-10.6zM379.4 176H132.6c-16.6 0-17.4 2.2-16.4 14.7l18.7 242.6c1.6 12.3 2.8 14.8 17.5 14.8h207.2c14.7 0 15.9-2.5 17.5-14.8l18.7-242.6c1-12.6.2-14.7-16.4-14.7z"></path></svg>    </i>
</script>