<?php
/**
 * Template for the individual project image thumbnail
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */

global $post;
?>

<script type="text/template" id="tmpl-ph-website-comment-dot">
	{{ Number(data.order) + 1 }}
</script>

<script type="text/html" id='tmpl-ph-comment-bubble-css'>
	<?php
    // create iframe
    $file = PH_WEBSITE_PLUGIN_DIR . 'assets/css/ph-website-comment-bubble.css';

    if (file_exists($file)) {
        readfile($file);
    }
	?>
	<?php echo ph_website_style_options(); ?>
</script>

<script type="text/html" id='tmpl-ph-comment-bubble-js'>
	<?php
    // create iframe
    $file = PH_WEBSITE_PLUGIN_DIR . 'assets/js/src/includes/quill.min.js';

    if (file_exists($file)) {
        readfile($file);
    }
	?>
</script>
<script type="text/template" id="tmpl-ph-comment-bubble">
	<div class="ph-comment-content">
		<!-- Comment Header -->
		<div class="ph-comment-header"></div>
		<!-- Comment Header -->

		<!-- Comment Text -->
		<div class="ph-comment-text"></div>
		<!-- Comment Text -->

		<!-- Comment Info -->
		<div class="hidden ph-comment-info"></div>
		<!-- Comment Info -->

		<!-- Comment Form -->
		<div class="ph-comment-form"></div>
		<!-- Comment Form -->

		<!-- Submit Button -->
		<div class="ph-comment-submit"></div>
	</div>
</script>

<!-- Comment Box Template -->
<script type="text/template" id="tmpl-website-comment">
	<div class="ph-comment-thread" style="left:{{data.x}}px; top:{{data.y}}px;">
		<div class="ph-annotation-dot <# if (data.resolved) { #> ph-approved<# } #>">
			{{ Number(data.order) + 1 }}
		</div>
		<div class="ph-comment-inner">

			<div class="ph-comment-wrapper animated ph-hidden">
				<div class="ph-comment-content">

					<!-- Comment Header -->
					<div class="ph-comment-header"></div>
					<!-- Comment Header -->

					<!-- Comment Text -->
					<div class="ph-comment-text"></div>
					<!-- Comment Text -->

					<!-- Comment Info -->
					<div class="hidden ph-comment-info"></div>
					<!-- Comment Info -->

					<!-- Comment Form -->
					<div class="ph-comment-form"></div>
					<!-- Comment Form -->

					<!-- Submit Button -->
					<div class="ph-comment-submit"></div>
				</div>

			</div>
		</div>
	</div>
</script>
<!-- Comment Box Template -->

<script type="text/template" id="tmpl-project-comment-header">
    <div class="ph-comment-header-left"></div>
    <div class="ph-comment-header-right"></div>
</script>

<script type="text/template" id="tmpl-ph-comment-tech-details">
	<div class="ph-dropdown-wrap ph-tech-detail-icon ph-right-dropdown ph-has-arrow ph-right-arrow ph-click-open">

		<div class="ph-tooltip-wrap bottom">
			<i class="ion-more">
				<svg viewBox="0 0 512 512" id="ion-more" width="12" height="12"><path d="M113.7 304C86.2 304 64 282.6 64 256c0-26.5 22.2-48 49.7-48 27.6 0 49.8 21.5 49.8 48 0 26.6-22.2 48-49.8 48zM256 304c-27.5 0-49.8-21.4-49.8-48 0-26.5 22.3-48 49.8-48 27.5 0 49.7 21.5 49.7 48 0 26.6-22.2 48-49.7 48zM398.2 304c-27.5 0-49.8-21.4-49.8-48 0-26.5 22.2-48 49.8-48 27.5 0 49.8 21.5 49.8 48 0 26.6-22.2 48-49.8 48z"></path></svg>
			</i>

			<div class="ph-tooltip">
				<?php _e( 'Details', 'project-huddle' ); ?>
			</div>
		</div>

		<div class="ph-dropdown">
			<div class="ph-dropdown-inner">
				<div class="ph-tech-item">
					{{ data.browser }} {{ data.browserVersion }}
				</div>
				<div class="ph-tech-item">
					{{ data.browserOS }}
				</div>
			</div>
		</div>
	</div>
</script>

<script type="text/html" id="tmpl-ph-detail-browser">
	<i class="ion-code">
		<svg viewBox="0 0 512 512" id="ion-code" width="12" height="12"><path d="M168 392a23.929 23.929 0 0 1-16.971-7.029l-112-112c-9.373-9.373-9.373-24.569 0-33.941l112-112c9.373-9.372 24.568-9.372 33.941 0 9.371 9.372 9.371 24.568 0 33.941L89.941 256l95.029 95.029c9.371 9.373 9.371 24.568 0 33.941A23.925 23.925 0 0 1 168 392zM344 392a23.929 23.929 0 0 0 16.971-7.029l112-112c9.373-9.373 9.373-24.569 0-33.941l-112-112c-9.373-9.372-24.568-9.372-33.941 0-9.371 9.372-9.371 24.568 0 33.941L422.059 256l-95.029 95.029c-9.371 9.373-9.371 24.568 0 33.941A23.925 23.925 0 0 0 344 392z"></path></svg>
	</i>
	{{ data.browser }} {{ data.browserVersion }}
</script>

<script type="text/html" id="tmpl-ph-detail-os">
	<# if (data.resX < 480 ) { #>
		<i class="ion-android-phone-portrait">
			<svg viewBox="0 0 512 512" id="ion-android-phone-portrait" width="12" height="12"><path d="M358.856 32H153.143C130.512 32 112 50.326 112 72.728v366.545C112 461.674 130.512 480 153.143 480h205.713C381.488 480 400 461.674 400 439.272V72.728C400 50.326 381.488 32 358.856 32zM364 400H148V112h216v288z"></path></svg>
		</i>
	<# } else if ( data.resX >= 480 && data.resX < 780 ) { #>
		<i class="ion-android-phone-landscape">
			<svg viewBox="0 0 512 512" id="ion-android-phone-landscape" width="12" height="12"><path d="M480 358.856V153.143C480 130.512 461.674 112 439.272 112H72.728C50.326 112 32 130.512 32 153.143v205.713C32 381.488 50.326 400 72.728 400h366.545C461.674 400 480 381.488 480 358.856zM112 364V148h288v216H112z"></path></svg>
		</i>
	<# } else if ( data.resX >= 780 ) { #>
		<i class="ion-android-desktop">
			<svg viewBox="0 0 512 512" id="ion-android-desktop" width="12" height="12"><path d="M437.333 32H74.667C51.198 32 32 51.197 32 74.666v282.667C32 380.802 51.198 400 74.667 400h138.666l-42.666 48v32h170.666v-32l-42.666-48h138.666C460.802 400 480 380.802 480 357.333V74.666C480 51.197 460.802 32 437.333 32zm0 288H74.667V74.666h362.666V320z"></path></svg>
		</i>
	<# } #>
	{{ data.browserOS }}
</script>

<script type="text/html" id="tmpl-ph-detail-resolution">
	<span class="ph-detail-icon">
		<i class="ion-android-expand">
			<svg viewBox="0 0 512 512" id="ion-android-expand" width="12" height="12"><path d="M396.795 396.8H320V448h128V320h-51.205zM396.8 115.205V192H448V64H320v51.205zM115.205 115.2H192V64H64v128h51.205zM115.2 396.795V320H64v128h128v-51.205z"></path></svg>
		</i>
	</span>
	{{ data.resX }} x {{ data.resY }}
</script>

<script type="text/html" id="tmpl-ph-detail-link">
	<span class="ph-detail-icon">
		<i class="ion-link">
			<svg viewBox="0 0 512 512" id="ion-link" width="12" height="12"><path d="M256.5 208h-.5.5zM368.5 160H320s26 17 31.6 48h16.9c17.6 0 31.5 13.9 31.5 31.5v32c0 17.6-13.9 32.5-31.5 32.5h-112c-17.6 0-32.5-14.9-32.5-32.5V240h-48v31.5c0 11.5 2.5 22.5 6.9 32.5 12.6 28.2 40.9 48 73.6 48h112c44.2 0 79.5-36.3 79.5-80.5v-32c0-44.2-35.3-79.5-79.5-79.5z"></path><path d="M329.6 208c-12.1-28.3-40.1-48-73.1-48h-112c-44.2 0-80.5 35.3-80.5 79.5v32c0 44.2 36.3 80.5 80.5 80.5H192s-25.8-17-32.1-48h-15.4c-17.6 0-32.5-14.9-32.5-32.5v-32c0-17.6 14.9-31.5 32.5-31.5h112c17.6 0 31.5 13.9 31.5 31.5V272h48v-32.5c0-11.2-2.3-21.9-6.4-31.5z"></path></svg>
		</i>
	</span>
	<a href="{{{ data.link }}}" onClick="prompt('<?php _e('Copy this shareable link:', 'project-huddle'); ?>', '{{{ data.link }}}'); return false;">
		<?php _e('Copy Share Link', 'project-huddle'); ?>
	</a>
</script>

<script type="text/html" id="tmpl-ph-detail-delete">
	<span class="ph-detail-icon">
		<i class="ion-trash-a">
			<svg viewBox="0 0 512 512" id="ion-trash-a" width="12" height="12"><path d="M341 128V99c0-19.1-14.5-35-34.5-35H205.4C185.5 64 171 79.9 171 99v29H80v32h9.2s5.4.6 8.2 3.4c2.8 2.8 3.9 9 3.9 9l19 241.7c1.5 29.4 1.5 33.9 36 33.9h199.4c34.5 0 34.5-4.4 36-33.8l19-241.6s1.1-6.3 3.9-9.1 8.2-3.4 8.2-3.4h9.2v-32h-91v-.1zM192 99c0-9.6 7.8-15 17.7-15h91.7c9.9 0 18.6 5.5 18.6 15v29H192V99zm-8.5 285l-10.3-192h20.3L204 384h-20.5zm83.6 0h-22V192h22v192zm61.6 0h-20.4l10.5-192h20.3l-10.4 192z"></path></svg>
		</i>
	</span>
	<?php _e('Trash', 'project-huddle'); ?>
</script>

<!-- Submit Button Template -->
<script type="text/template" id="tmpl-project-comment-submit-button">
	<?php _e( 'Add Comment', 'project-huddle' ); ?>
</script>
<!-- Submit Button Template -->

<!-- Submit Button Template -->
<script type="text/template" id="tmpl-ph-comment-cancel-button">
	<?php _e( 'Cancel', 'project-huddle' ); ?>
</script>
<!-- Submit Button Template -->

<script type="text/template" id="tmpl-ph-resolve-check">
	<i class="ph-icon loading"></i>
	<# if (!data.resolved || data.resolved == 'false') { #>
		<i class="ph-icon checkbox ion-android-checkbox-outline-blank">
			<svg viewBox="0 0 512 512" id="ion-android-checkbox-outline-blank" width="16" height="16"><path d="M405.333 106.667v298.666H106.667V106.667h298.666m0-42.667H106.667C83.198 64 64 83.198 64 106.667v298.666C64 428.802 83.198 448 106.667 448h298.666C428.802 448 448 428.802 448 405.333V106.667C448 83.198 428.802 64 405.333 64z"></path></svg>
		</i>
		<?php _e('Resolve', 'project-huddle'); ?>
	<# } else { #>
		<i class="ph-icon checkbox ion-android-checkbox ph-approved">
			<svg viewBox="0 0 512 512" id="ion-android-checkbox" width="16" height="16"><path d="M405.333 64H106.667C83.198 64 64 83.198 64 106.667v298.666C64 428.802 83.198 448 106.667 448h298.666C428.802 448 448 428.802 448 405.333V106.667C448 83.198 428.802 64 405.333 64zm-192 298.667L106.667 256l29.864-29.864 76.802 76.802 162.136-162.136 29.864 29.865-192 192z"></path></svg>
		</i>
		<?php _e('Resolved', 'project-huddle'); ?>
	<# } #>
</script>

<script type="text/template" id="tmpl-ph-comment-info">
	<i class="ph-icon ion-ios-information"></i>
</script>

<script type="text/template" id="tmpl-ph-close-comment">
	<i class="ph-icon ph-hide-bubble ion-android-close">
		<svg viewBox="0 0 512 512" id="ion-android-close" width="13" height="13"><path d="M405 136.798L375.202 107 256 226.202 136.798 107 107 136.798 226.202 256 107 375.202 136.798 405 256 285.798 375.202 405 405 375.202 285.798 256z"></path></svg>
	</i>
</script>