<?php global $post; ?>
<!-- Panel Container  -->

<script type="text/html" id='tmpl-ph-panel-css'>
	<?php
    // create iframe
    $file = PH_WEBSITE_PLUGIN_DIR . 'assets/css/ph-website-panel.css';

    if (file_exists($file)) {
        readfile($file);
    }
	?>
	<?php echo ph_website_style_options(); ?>
</script>
<script type="text/html" id='tmpl-ph-panel'>
	<div class="ph-panel-inner">
		<div class="ph-panel-header-wrap has-shadow dark">
			<div class="ph-panel-header">
				<i class="ph-icon ion-android-close ph-close" title="<?php _e( 'Close Sidebar', 'project-huddle' ); ?>">
					<svg viewBox="0 0 512 512" id="ion-close" width="12" height="12"><path d="M443.6 387.1L312.4 255.4l131.5-130c5.4-5.4 5.4-14.2 0-19.6l-37.4-37.6c-2.6-2.6-6.1-4-9.8-4-3.7 0-7.2 1.5-9.8 4L256 197.8 124.9 68.3c-2.6-2.6-6.1-4-9.8-4-3.7 0-7.2 1.5-9.8 4L68 105.9c-5.4 5.4-5.4 14.2 0 19.6l131.5 130L68.4 387.1c-2.6 2.6-4.1 6.1-4.1 9.8 0 3.7 1.4 7.2 4.1 9.8l37.4 37.6c2.7 2.7 6.2 4.1 9.8 4.1 3.5 0 7.1-1.3 9.8-4.1L256 313.1l130.7 131.1c2.7 2.7 6.2 4.1 9.8 4.1 3.5 0 7.1-1.3 9.8-4.1l37.4-37.6c2.6-2.6 4.1-6.1 4.1-9.8-.1-3.6-1.6-7.1-4.2-9.7z"></path></svg>
				</i>

				<?php if ( $logo = apply_filters( 'ph_website_control_logo_id', get_option( 'ph_website_control_logo' ) ) ) : ?>
					<div class="ph-panel-title-item ph-panel-logo-wrap">
						<div class="ph-panel-logo">
							<?php
							// get logo image
							$logo_image = wp_get_attachment_image_src( $logo, 'full' );

							// check retina option
							if ( apply_filters( 'ph_website_control_logo_retina', get_option( 'ph_website_control_logo_retina' ) ) ) :
								$logo_image[1] = $logo_image[1] / 2;
								$logo_image[2] = $logo_image[2] / 2;
							endif;
							?>

							<a href="<?php echo home_url(); ?>">
								<img src="<?php echo esc_url( $logo_image[0] ); ?>" width="<?php echo (float) $logo_image[1]; ?>" height="<?php echo (float) $logo_image[2]; ?>"/>
							</a>

						</div>
					</div>
				<?php endif; ?>

				<div class="ph-panel-title-item">
					<div class="ph-tab ph-active ph-comments-tab">
						<?php _e( 'Comments', 'project-huddle' ); ?>
					</div>
					<div class="ph-tab ph-pages-tab">
						<?php _e( 'Pages', 'project-huddle' ); ?>
					</div>
				</div>
			</div>
		</div>
		<div class="ph-panel-subheading ph-show-comments ph-active"></div>
		<div class="ph-panel-body">
			<div class="ph-panel-tab-content ph-panel-comments-list ph-comments-tab ph-active"></div>
			<div class="ph-panel-tab-content ph-pages-tab ph-panel-pages-list"></div>
		</div>
		<div class="ph-panel-footer">
			<div class="left-col">
				<?php if ( is_user_logged_in() ) : ?>
					<?php if ( current_user_can( 'edit_ph-website', $post->ID ) ) : ?>
						<a href="<?php echo esc_url( get_edit_post_link($post->ID) ); ?>" target="_blank" class="ph-icon">
							<i class="ion-android-settings" title="<?php _e( 'Manage', 'project-huddle' ); ?>">
								<svg viewBox="0 0 512 512" id="ion-android-settings" width="12" height="12"><path d="M413.967 276.8c1.06-6.235 1.06-13.518 1.06-20.8s-1.06-13.518-1.06-20.8l44.667-34.318c4.26-3.118 5.319-8.317 2.13-13.518L418.215 115.6c-2.129-4.164-8.507-6.235-12.767-4.164l-53.186 20.801c-10.638-8.318-23.394-15.601-36.16-20.801l-7.448-55.117c-1.06-4.154-5.319-8.318-10.638-8.318h-85.098c-5.318 0-9.577 4.164-10.637 8.318l-8.508 55.117c-12.767 5.2-24.464 12.482-36.171 20.801l-53.186-20.801c-5.319-2.071-10.638 0-12.767 4.164L49.1 187.365c-2.119 4.153-1.061 10.399 2.129 13.518L96.97 235.2c0 7.282-1.06 13.518-1.06 20.8s1.06 13.518 1.06 20.8l-44.668 34.318c-4.26 3.118-5.318 8.317-2.13 13.518L92.721 396.4c2.13 4.164 8.508 6.235 12.767 4.164l53.187-20.801c10.637 8.318 23.394 15.601 36.16 20.801l8.508 55.117c1.069 5.2 5.318 8.318 10.637 8.318h85.098c5.319 0 9.578-4.164 10.638-8.318l8.518-55.117c12.757-5.2 24.464-12.482 36.16-20.801l53.187 20.801c5.318 2.071 10.637 0 12.767-4.164l42.549-71.765c2.129-4.153 1.06-10.399-2.13-13.518l-46.8-34.317zm-158.499 52c-41.489 0-74.46-32.235-74.46-72.8s32.971-72.8 74.46-72.8 74.461 32.235 74.461 72.8-32.972 72.8-74.461 72.8z"></path></svg>
							</i>
							<?php _e( 'Manage', 'project-huddle' ); ?>
						</a>
					<?php else : ?>
						<a href="<?php echo wp_logout_url( get_post_meta( $post->ID, 'website_url', true ) ); ?>" target="_blank" class="ph-icon">
							<i class="ion-log-out" title="<?php _e( 'Logout', 'project-huddle' ); ?>">
								<svg viewBox="0 0 512 512" id="ion-log-out" width="10" height="10"><path d="M366.863 323.883l22.627 22.627L480 256l-90.51-90.51-22.628 22.628L418.745 240H192v32h226.745z"></path><path d="M391.491 391.766C355.229 428.029 307.018 448 255.736 448c-51.287 0-99.506-19.971-135.772-56.235C83.697 355.501 64 307.285 64 256c0-51.281 19.697-99.495 55.965-135.761C156.232 83.973 204.45 64 255.736 64c51.279 0 99.491 19.973 135.755 56.238a196.044 196.044 0 0 1 7.333 7.762h40.731c-40.474-58.028-107.709-96-183.819-96C132.021 32 32 132.298 32 256c0 123.715 100.021 224 223.736 224 76.112 0 143.35-37.97 183.822-96h-40.73a194.792 194.792 0 0 1-7.337 7.766z"></path></svg>
							</i>
							<?php _e( 'Logout', 'project-huddle' ); ?>
						</a>
					<?php endif; ?>
				<?php endif; ?>
			</div>
			<div class="middle-col">
			</div>
			<div class="right-col">
				<?php if ( $link = get_option( 'ph_help_link', '' ) ) : ?>
					<a href="<?php echo esc_url( $link ); ?>" target="_blank" class="ph-icon">
						<i class="ion-help-circled" title="<?php _e( 'Help', 'project-huddle' ); ?>">
							<svg viewBox="0 0 512 512" id="ion-help-circled" width="10" height="10"><path d="M256 32C132.3 32 32 132.3 32 256s100.3 224 224 224 224-100.3 224-224S379.7 32 256 32zm20.2 326.7c-.5 17.8-13.7 28.8-30.8 28.3-16.4-.5-29.3-12.2-28.8-30.1.5-17.8 14.1-29.1 30.5-28.6 17.2.5 29.7 12.6 29.1 30.4zm48.7-127.3c-4.2 5.9-13.6 13.5-25.4 22.7l-13.1 9c-6.4 4.9-10.4 10.7-12.5 17.3-1.1 3.5-1.9 12.6-2.1 18.7-.1 1.2-.8 3.9-4.5 3.9h-39.1c-4.1 0-4.6-2.4-4.5-3.6.6-16.6 3-30.3 9.9-41.3 9.3-14.8 35.5-30.4 35.5-30.4 4-3 7.1-6.2 9.5-9.7 4.4-6 8-12.7 8-19.9 0-8.3-2-16.2-7.3-22.8-6.2-7.7-12.9-11.4-25.8-11.4-12.7 0-20.1 6.4-25.4 14.8-5.3 8.4-4.4 18.3-4.4 27.3H175c0-34 8.9-55.7 27.7-68.5 12.7-8.7 28.9-12.5 47.8-12.5 24.8 0 44.5 4.6 61.9 17.8 16.1 12.2 24.6 29.4 24.6 52.6 0 14.3-5 26.3-12.1 36z"></path></svg>
						</i>
						<?php _e( 'Help', 'project-huddle' ); ?>
					</a>
				<?php endif; ?>
			</div>
		</div>
	</div>
</script>
<!-- Panel Container -->

<script type="text/html" id='tmpl-ph-panel-empty-comments'>
	<?php _e('No Comments', 'project-huddle'); ?>
</script>
<script type="text/html" id='tmpl-ph-panel-empty-pages'>
	<?php _e('No Pages', 'project-huddle'); ?>
</script>


<!-- Panel Comment Item  -->
<script type="text/html" id='tmpl-ph-panel-item'>
	<div class="ph-comment-avatar ph-navigate">
		<div class="ph-avatar">
			<div class="avatar"></div>

			<div class="ph-comment-count<# if (data.resolved) { #> ph-approved<# } #>" <# if (data.comment_count <= 1 && ! data.resolved) { #> style="display:none;" <# } #>>
				<# if (data.resolved) { #>
					<div class="ph-approval-indicator">
						<i class="ion-checkmark">
							<svg viewBox="0 0 512 512" id="ion-checkmark" width="8" height="8"><path d="M461.6 109.6l-54.9-43.3c-1.7-1.4-3.8-2.4-6.2-2.4-2.4 0-4.6 1-6.3 2.5L194.5 323s-78.5-75.5-80.7-77.7c-2.2-2.2-5.1-5.9-9.5-5.9s-6.4 3.1-8.7 5.4c-1.7 1.8-29.7 31.2-43.5 45.8-.8.9-1.3 1.4-2 2.1-1.2 1.7-2 3.6-2 5.7 0 2.2.8 4 2 5.7l2.8 2.6s139.3 133.8 141.6 136.1c2.3 2.3 5.1 5.2 9.2 5.2 4 0 7.3-4.3 9.2-6.2l249.1-320c1.2-1.7 2-3.6 2-5.8 0-2.5-1-4.6-2.4-6.4z"></path></svg>
						</i>
					</div>
				<# } #>

				{{ data.comment_count - 1 }}
			</div>
		</div>

		<div class="ph-comment-item-date">
			{{ data.humanDate }}
		</div>

		<!--<div class="ph-comment-number">-->
			<!--{{ Number(data.order) + 1 }}-->
		<!--</div>-->
	</div>

	<div class="ph-comment-content">
		<div class="ph-comment-header">
			<div class="ph-comment-author ph-navigate">
				{{ data.author_name }}
			</div>
			<div class="ph-comment-header-left"></div>
			<div class="ph-comment-header-right"></div>
		</div>
		<div class="ph-comment-item-content ph-navigate">
			{{{ data.content }}}
		</div>
		<div class="ph-comment-item-details">
			<div class="ph-tooltip-wrap ph-navigate">
				<i class="ion-location">
					<svg viewBox="0 0 512 512" id="ion-location" width="12" height="12"><path d="M256 64c-65.9 0-119.3 53.7-119.3 120 0 114.6 119.3 264 119.3 264s119.3-149.4 119.3-264c0-66.3-53.4-120-119.3-120zm0 178.2c-31.2 0-56.4-25.4-56.4-56.7 0-31.3 25.3-56.8 56.4-56.8 31.2 0 56.4 25.4 56.4 56.8 0 31.3-25.2 56.7-56.4 56.7z"></path></svg>
				</i>
				<div class="ph-tooltip">
					<?php _e( 'View Location', 'project-huddle' ); ?>
					<i class="ion-arrow-right-c">
						<svg viewBox="0 0 512 512" id="ion-arrow-right-c" width="10" height="10"><path d="M322.7 128.4l100.3 105c6 5.8 9 13.7 9 22.4s-3 16.5-9 22.4L322.7 383.6c-11.9 12.5-31.3 12.5-43.2 0-11.9-12.5-11.9-32.7 0-45.2l48.2-50.4h-217c-17 0-30.7-14.3-30.7-32s13.7-32 30.6-32h217l-48.2-50.4c-11.9-12.5-11.9-32.7 0-45.2 12-12.5 31.3-12.5 43.3 0z"></path></svg>
					</i>
				</div>
			</div>
			<div class="ph-tooltip-wrap">
				<# if (data.resX < 480 ) { #>
					<i class="ion-android-phone-portrait">
						<svg viewBox="0 0 512 512" id="ion-android-phone-portrait" width="12" height="12"><path d="M358.856 32H153.143C130.512 32 112 50.326 112 72.728v366.545C112 461.674 130.512 480 153.143 480h205.713C381.488 480 400 461.674 400 439.272V72.728C400 50.326 381.488 32 358.856 32zM364 400H148V112h216v288z"></path></svg>
					</i>
				<# } else if ( data.resX >= 480 && data.resX < 780 ) { #>
					<i class="ion-android-phone-landscape">
						<svg viewBox="0 0 512 512" id="ion-android-phone-landscape" width="12" height="12"><path d="M480 358.856V153.143C480 130.512 461.674 112 439.272 112H72.728C50.326 112 32 130.512 32 153.143v205.713C32 381.488 50.326 400 72.728 400h366.545C461.674 400 480 381.488 480 358.856zM112 364V148h288v216H112z"></path></svg>
					</i>
				<# } else if ( data.resX >= 780 ) { #>
					<i class="ion-android-desktop">
						<svg viewBox="0 0 512 512" id="ion-android-desktop" width="12" height="12"><path d="M437.333 32H74.667C51.198 32 32 51.197 32 74.666v282.667C32 380.802 51.198 400 74.667 400h138.666l-42.666 48v32h170.666v-32l-42.666-48h138.666C460.802 400 480 380.802 480 357.333V74.666C480 51.197 460.802 32 437.333 32zm0 288H74.667V74.666h362.666V320z"></path></svg>
					</i>
				<# } #>
				<div class="ph-tooltip">
					{{ data.browser }} {{ data.browserVersion }} <br>
					{{ data.browserOS }}
				</div>
			</div>
			<div class="ph-tooltip-wrap">
				<i class="ion-android-expand">
					<svg viewBox="0 0 512 512" id="ion-android-expand" width="12" height="12"><path d="M396.795 396.8H320V448h128V320h-51.205zM396.8 115.205V192H448V64H320v51.205zM115.205 115.2H192V64H64v128h51.205zM115.2 396.795V320H64v128h128v-51.205z"></path></svg>
				</i>
				<div class="ph-tooltip">
					{{ data.resX }} x {{ data.resY }}
				</div>
			</div>
			<div class="ph-tooltip-wrap ph-navigate" data-focus="true">
				<i class="ion-reply">
					<svg viewBox="0 0 512 512" id="ion-reply" width="12" height="12"><path d="M448 400s-36.8-208-224-208v-80L64 256l160 134.4v-92.3c101.6 0 171 8.9 224 101.9z"></path></svg>
				</i>
				<div class="ph-tooltip">
					<?php _e('Reply', 'project-huddle' ); ?>
					<i class="ion-arrow-right-c">
						<svg viewBox="0 0 512 512" id="ion-arrow-right-c" width="10" height="10"><path d="M322.7 128.4l100.3 105c6 5.8 9 13.7 9 22.4s-3 16.5-9 22.4L322.7 383.6c-11.9 12.5-31.3 12.5-43.2 0-11.9-12.5-11.9-32.7 0-45.2l48.2-50.4h-217c-17 0-30.7-14.3-30.7-32s13.7-32 30.6-32h217l-48.2-50.4c-11.9-12.5-11.9-32.7 0-45.2 12-12.5 31.3-12.5 43.3 0z"></path></svg>
					</i>
				</div>
			</div>

<!--            <span class="ph-unread-comments ph-badge">-->
<!--                5 Unread-->
<!--            </span>-->
		</div>
	</div>
</script>

<!-- Panel Page Item -->
<script type="text/html" id='tmpl-ph-panel-page-item'>
	<# var percent = (data.resolved_count / data.comment_count ) * 100; #>
	<div class="ph-page-title">
		<a href="{{ data.page_url }}">{{{ data.title.rendered }}}</a>
	</div>
	<div class="ph-page-url">
		<a href="{{ data.page_url }}">
			<# var parsed = data.page_url.replace(/(^\w+:|^)\/\//, ''); #>
			{{ parsed }}
		</a>
	</div>
	<div class="ph-comment-progress-wrap <# if (percent >= 100) { #> ph-approved<# } #>">
		<div class="ph-comment-count">{{ data.comment_count }}</div>
		<div class="ph-approval-progress-bar-wrap ph-tooltip-wrap">
			<div class="ph-approval-progress-bar">
				<div class="ph-approval-progress" style="width:{{ percent }}%"></div>
				<div class="ph-tooltip">
					<?php echo sprintf( __('%1s of %2s resolved', 'project-huddle'), '{{ data.resolved_count }}', '{{ data.comment_count }}' ); ?>
				</div>
			</div>
		</div>
		<a  href="{{ data.page_url }}" class="ph-badge ph-visit-page-link">
			<?php _e( 'Visit Page', 'project-huddle' ); ?>
			<i class="ion-arrow-right-c">
				<svg viewBox="0 0 512 512" id="ion-arrow-right-c" width="10" height="10"><path d="M322.7 128.4l100.3 105c6 5.8 9 13.7 9 22.4s-3 16.5-9 22.4L322.7 383.6c-11.9 12.5-31.3 12.5-43.2 0-11.9-12.5-11.9-32.7 0-45.2l48.2-50.4h-217c-17 0-30.7-14.3-30.7-32s13.7-32 30.6-32h217l-48.2-50.4c-11.9-12.5-11.9-32.7 0-45.2 12-12.5 31.3-12.5 43.3 0z"></path></svg>
			</i>
		</a>
	</div>
</script>
<!-- Panel Page Item -->