<?php
/**
 * Redirects to actual website comment on single page view
 *
 * Sets a cookie
 */
global $post;

// use a session
PH()->session->set( 'ph_comment_id', (int) $post->ID );

// get page url from thread
$thread       = PHW()->thread->get_item( $post->ID );
$website_page = PHW()->page->get_item( $thread['parent_id'] );

// make sure we have a website url
if ( $website_page['page_url'] ) {
	$access = ph_user_validate_access();

	if ( is_wp_error( $access ) ) {
		wp_die( $access->get_error_message() );
	}

	if ( $access ) {
		wp_redirect( esc_url( $website_page['page_url'] ) );
	}
} else {
	?>
    <html>
    <head>
        <!-- make sure it's not indexed -->
        <meta name="robots" content="noindex, nofollow">
    </head>
    <body>
	<?php _e( 'Website URL is incorrect or not set.', 'project-huddle' ); ?>
    </body>
    </html>
<?php } ?>