<?php
/**
 * Redirects to actual website on Single Website page view
 */

// make sure we have a website url
if ( $website = get_post_meta( get_the_ID(), 'ph_website_url', true ) ) {
	$access = ph_user_validate_access();

	if ( is_wp_error( $access ) ) {
		wp_die( $access->get_error_message() );
	}

	if ( $access ) {
		wp_redirect( esc_url( $website ) );
	}
} else {
	?>
    <html>
    <head>
        <!-- make sure it's not indexed -->
        <meta name="robots" content="noindex, nofollow">
    </head>
    <body>
	<?php _e( 'Website URL is incorrect or not set.', 'project-huddle' ); ?>
    </body>
    </html>
<?php } ?>