<?php

/**
 * Deprecated Hooks
 * Please use new actions according to comments below
 */
class PH_Deprecated_Hooks {
	public function __construct() {
		// locations
		add_action( 'ph_mockup_new_thread', array( $this, 'deprecated_mockup_new_thread' ) );
		add_action( 'ph_mockup_after_new_thread', array( $this, 'deprecated_after_mockup_new_thread' ) );
		add_action( 'ph_mockup_edit_thread', array( $this, 'deprecated_mockup_edit_thread' ) );
		add_action( 'ph_mockup_after_edit_thread', array( $this, 'deprecated_after_mockup_edit_thread' ) );
		add_action( 'ph_mockup_delete_thread', array( $this, 'deprecated_mockup_delete_thread' ) );
		add_action( 'ph_mockup_after_delete_thread', array( $this, 'deprecated_after_mockup_delete_thread' ) );

		// comments
		add_action( 'ph_mockup_new_comment', array( $this, 'deprecated_mockup_new_comment' ) );
		add_action( 'ph_mockup_after_new_comment', array( $this, 'deprecated_after_mockup_new_comment' ) );
		add_action( 'ph_mockup_edit_comment', array( $this, 'deprecated_mockup_edit_comment' ) );
		add_action( 'ph_mockup_after_edit_comment', array( $this, 'deprecated_after_mockup_edit_comment' ) );
		add_action( 'ph_mockup_delete_comment', array( $this, 'deprecated_mockup_delete_comment' ) );
		add_action( 'ph_mockup_after_delete_comment', array( $this, 'deprecated_after_mockup_delete_comment' ) );
	}

	// new
	public function deprecated_mockup_new_comment( $data ) {
		$user = wp_get_current_user();
		do_action_deprecated( 'ph_insert_comment_before', array(
			$data,
			$data['project_id'],
			$data['image_id'],
			$user
		), '2.0', 'ph_mockup_new_comment' );
	}
	public function deprecated_after_mockup_new_comment( $data ) {
		$user = wp_get_current_user();
		do_action_deprecated( 'ph_insert_comment_after', array(
			$data['id'],
			$data,
			$data['image_id'],
			$user
		), '2.0', 'ph_mockup_new_comment' );
	}

	// edit
	public function deprecated_mockup_edit_comment( $data ) {
		do_action_deprecated( 'ph_update_comment_before', array( $data ), '2.0', 'ph_mockup_edit_comment' );
	}
	public function deprecated_after_mockup_edit_comment( $data ) {
		do_action_deprecated( 'ph_update_comment_after', array( $data ), '2.0', 'ph_mockup_after_edit_comment' );
	}

	// delete
	public function deprecated_mockup_delete_comment( $data ) {
		do_action_deprecated( 'ph_trash_comment_before', array( $data ), '2.0', 'ph_mockup_delete_comment' );
	}
	public function deprecated_after_mockup_delete_comment( $data ) {
		do_action_deprecated( 'ph_trash_comment_after', array( $data ), '2.0', 'ph_mockup_after_delete_comment' );
	}

	/**
	 * Threads
	 */

	// new
	public function deprecated_mockup_new_thread( $data ) {
		do_action_deprecated( 'ph_save_comment_location_before', array(
			$data
		), '2.0', 'ph_mockup_new_thread' );
	}
	public function deprecated_after_mockup_new_thread( $data ) {
		do_action_deprecated( 'ph_save_comment_location_after', array(
			$data,
			$data['project_id']
		), '2.0', 'ph_mockup_new_thread' );
	}

	// edit
	public function deprecated_mockup_edit_thread( $data ) {
		do_action_deprecated( 'ph_update_thread_before', array( $data ), '2.0', 'ph_mockup_edit_thread' );
	}
	public function deprecated_after_mockup_edit_thread( $data ) {
		do_action_deprecated( 'ph_update_thread_after', array( $data ), '2.0', 'ph_mockup_after_edit_thread' );
	}

	// delete
	public function deprecated_mockup_delete_thread( $data ) {
		do_action_deprecated( 'ph_trash_thread_before', array( $data ), '2.0', 'ph_mockup_delete_thread' );
	}
	public function deprecated_after_mockup_delete_thread( $data ) {
		do_action_deprecated( 'ph_trash_thread_after', array( $data ), '2.0', 'ph_mockup_after_delete_thread' );
	}
}

//new PH_Deprecated_Hooks();