<?php
/**
 * Functions necessary for dismissing notices
 */

/**
 * Output javascript necessary for dismissing notices
 */
function ph_dismiss_js() { ?>
    <script>
        jQuery(function ($) {
            $(document).on('click', '.ph-notice .notice-dismiss', function () {
                // Read the "data-notice" information to track which notice
                var type = $(this).closest('.ph-notice').data('notice');
                // Since WP 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
                $.ajax(ajaxurl,
                    {
                        type: 'POST',
                        data: {
                            action: 'ph_dismissed_notice_handler',
                            type  : type
                        }
                    });
            });
        });
    </script>
<?php }

/**
 * Stores notice dismissing in options table
 */
function ph_ajax_notice_handler() {
	$type = isset( $_POST['type'] ) ? $_POST['type'] : false;
	// Store it in the options table
	if ( $type ) {
		update_option( "dismissed-$type", true );
	}
}

add_action( 'wp_ajax_ph_dismissed_notice_handler', 'ph_ajax_notice_handler' );