<?php
/**
 * Template for the individual project image thumbnail
 *
 * @package     ProjectHuddle
 * @subpackage  app/templates
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */

global $post; ?>

<!-- Image Thumb Template -->
<script type="text/template" id="tmpl-single-project">

	<!-- Hidden ID and Title -->
	<input type="hidden" name="ph-project-id[]" value="{{ data.id }}" />
	<input type="hidden" name="ph-project-title[]" value="{{ data.title }}" />
	<input type="hidden" name="ph-project-imageID[]" value="{{ data.imageID }}" />

	<!-- Image Options -->
	<?php foreach ( PH()->image->project_options as $key => $option ) : ?>
		<input type="hidden" name="<?php echo esc_attr( $key ); ?>[]" value="{{ data.options.<?php echo esc_attr( $key ); ?> }}" />
	<?php endforeach; ?>

	<?php do_action( 'ph_meta_box_image_hidden_fields', $post ); ?>

	<div class="ph-image-wrapper" <# if (data.options.ph_image_background_color && data.options.ph_image_background_color != 'false' ) { #>
		style="background: {{ data.options.ph_image_background_color }}"
		<# } else {#>
			style="background: <?php echo esc_attr( get_option('ph_image_bg') ); ?>"
		<# } #>>

		<div class="ph-overlay"></div>

		<div class="ph-image" style="background-image: url({{ data.thumbnail }});"></div>

		<?php do_action( 'ph_meta_box_image_overlay', $post ); ?>

		<span class="ph-image-view ph-project-action">
			<# if ( data.hash ) { #>
				<a href="<?php the_permalink(); ?>#{{ data.hash }}">
					<?php _e( 'View Image', 'project-huddle' ); ?>
				</a>
			<# } #>
		</span>
	</div>

	<div class="ph-content-wrapper">

		<div class="ph-title">
			<div class="ph-title-inner">
				<h3>
					<?php do_action( 'ph_meta_box_image_title_before', $post ); ?>
					{{ data.title }}
					<?php do_action( 'ph_meta_box_image_title_after', $post ); ?>
				</h3>
				<i class="ph-icon ph-edit ion-android-create"></i>
			</div>

			<div class="ph-edit-textarea ph-hidden">
				<textarea class="ph-edit-content" rows="1">{{ data.title }}</textarea>
				<button class="ph-button ph-edit-save button button-primary"><?php _e( 'Set Title', 'project-huddle' ); ?></button>
				<button class="ph-secondary-link ph-edit-cancel button"><?php _e( 'Cancel', 'project-huddle' ); ?></button>
			</div>
		</div>

		<div class="ph-project-actions">

			<?php do_action( 'ph_meta_box_image_comment_count_before', $post ); ?>

			<span class="ph-comments-count ph-project-action">
				<span class="ph-icon ion-chatbubble"></span> {{ data.comment_count }}
			</span>

			<?php do_action( 'ph_meta_box_image_comment_count_after', $post ); ?>

			<span class="ph-project-actions-right">

				<span class="ph-settings-wrap">
					<span class="ph-settings-menu-wrap">
						<ul class="ph-settings-menu"></ul>
					</span>

					<span class="ph-project-action ph-settings-open">
						<span class="ph-icon ion-gear-b"></span>
					</span>
				</span>
			</span>

		</div>

	</div>

</script>
<!-- Image Thumb Template -->