<?php
/**
 * Template for the individual project image thumbnail
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */

global $post;
?>

<!-- Comment Box Template -->
<script type="text/template" id="tmpl-project-comment">
    <div class="ph-annotation-dot">{{data.order + 1}}</div>
    <div class="ph-comment-inner">

        <div class="ph-comment-wrapper animated">
            <div class="ph-comment-content">

                <!-- Comment Header -->
                <div class="ph-comment-header"></div>
                <!-- Comment Header -->

                <!-- Comment Text -->
                <div class="ph-comment-text"></div>
                <!-- Comment Text -->

                <!-- Comment Info -->
                <div class="hidden ph-comment-info"></div>
                <!-- Comment Info -->

                <!-- Comment Form -->
                <div class="ph-comment-form"></div>
                <!-- Comment Form -->

                <!-- Submit Button -->
                <div class="ph-comment-submit"></div>
            </div>

        </div>
    </div>
</script>
<!-- Comment Box Template -->

<!-- Comment Header Template -->
<script type="text/template" id="tmpl-project-comment-header">

	<div class="ph-dropdown click-trigger">

		<div class="ph-select-text">

		<span class="ph-category-select-text">
			<?php _e( 'Comment', 'project-huddle' ); ?>
		</span>

			<i class="ph-icon ion-chevron-down"></i>
		</div>

		<div class="ph-select-dropdown ph-hidden">
			<div class="ph-select-content">
				<?php if ( 'off' != get_post_meta( $post->ID, 'ph_project_sharing', true ) ) : ?>
					<div class="ph-select-row ph-share-comment">
						<i class="ph-icon ion-android-share"></i>
						<?php _e( 'Share Comment', 'project-huddle' ); ?>
					</div>
				<?php endif; ?>
				<div class="ph-select-row ph-copy-link">
					<i class="ph-icon ion-link"></i>
					<?php _e( 'Get Comment Link', 'project-huddle' ); ?>
				</div>
				<?php if ( current_user_can( 'edit_ph-project', $post->ID ) ) { ?>
					<div class="ph-select-row ph-delete-comment-location"
					     data-confirm="<?php _e( 'Are you sure you want to delete this comment thread?', 'project-huddle' ); ?>">
						<i class="ph-icon ion-trash-b"></i>
						<?php _e( 'Delete Thread', 'project-huddle' ); ?>
					</div>
				<?php } ?>
			</div>
		</div>
	</div>

	<span class="ph-header-controls">
		<i class="ph-icon ph-hide-bubble ion-android-close"></i>
	</span>

</script>
<!-- Comment Header Template -->

<!-- Submit Button Template -->
<script type="text/template" id="tmpl-project-comment-submit-button">
	<?php _e( 'Add Comment', 'project-huddle' ); ?>
</script>
<!-- Submit Button Template -->

<!-- Submit Button Template -->
<script type="text/template" id="tmpl-ph-comment-cancel-button">
	<?php _e( 'Cancel', 'project-huddle' ); ?>
</script>
<!-- Submit Button Template -->