<?php
/**
 * Template for the identify dialog popup
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */
?>

<!-- Identify Dialog Template -->
<script type="text/template" id="tmpl-dialog-identify">
	<form class="vex-dialog-form">

		<div class="vex-dialog-message">
			<?php echo apply_filters( 'ph_identify_dialog_message', __( 'Before you do that, please tell us about yourself!', 'project-huddle' ) ); ?>
		</div>

		<div class="vex-dialog-input">

			<?php do_action( 'ph_before_identify_dialog_inputs' ); ?>

			<input name="username" type="text" placeholder="<?php _e( 'Your Name', 'project-huddle' ); ?>" required/>
			<input name="email" type="email" placeholder="<?php _e( 'Email Address', 'project-huddle' ); ?>" required/>

			<?php do_action( 'ph_after_identify_dialog_inputs' ); ?>

		</div>

		<div class="vex-dialog-buttons">

			<?php do_action( 'ph_before_identify_dialog_buttons' ); ?>

			<button type="submit" class="vex-dialog-button-primary vex-dialog-button vex-first ph-dialog-submit">
				<?php _e( 'Done', 'project-huddle' ); ?>
			</button>
			<button type="button" class="vex-dialog-button-secondary vex-dialog-button ph-dialog-cancel">
				<?php _e( 'Cancel', 'project-huddle' ); ?>
			</button>
			<button type="button" class="vex-dialog-link vex-last ph-dialog-login">
				<?php _e( 'Login', 'project-huddle' ); ?>
			</button>

			<?php do_action( 'ph_after_identify_dialog_buttons' ); ?>
		</div>

	</form>
</script>
<!-- Identify Dialog Template -->