<?php
/**
 * Template for the login dialog popup
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */
?>

<!-- Login Form Dialog Template -->
<script type="text/template" id="tmpl-dialog-login">
	<form class="vex-dialog-form">

		<div class="vex-dialog-message">
			<?php echo apply_filters( 'ph_login_dialog_message', __('Enter your username &amp; password', 'project-huddle') ); ?>
		</div>

		<div class="vex-dialog-input">

			<?php do_action('ph_before_login_dialog_inputs'); ?>

			<input name="username" type="text" placeholder="<?php _e( 'Username', 'project-huddle' ); ?>" required />
			<input name="password" type="password" placeholder="<?php _e( 'Password', 'project-huddle' ); ?>" required />

			<?php do_action('ph_after_login_dialog_inputs'); ?>

		</div>

		<div class="vex-dialog-buttons">

			<?php do_action('ph_before_login_dialog_buttons'); ?>

			<button type="submit" class="vex-dialog-button-primary vex-dialog-button vex-first ph-dialog-submit">
				<?php _e( 'Login', 'project-huddle' ); ?>
			</button>
			<button type="button" class="vex-dialog-button-secondary vex-dialog-button ph-dialog-cancel">
				<?php _e( 'Back', 'project-huddle' ); ?>
			</button>
			<a href="<?php echo wp_lostpassword_url( get_permalink() ); ?>" type="button" class="vex-dialog-link vex-last ph-forgot-password">
				<?php _e( 'Forgot your password?', 'project-huddle' ); ?>
			</a>
			<?php do_action('ph_after_login_dialog_buttons'); ?>
		</div>

	</form>
</script>
<!-- Login Form Dialog Template -->