<?php
/**
 * The Template for displaying all single projects.
 *
 * Override this template by copying it to your theme or child theme
 *
 * @package     ProjectHuddle
 * @subpackage  templates
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

$access = get_post_meta( $post->ID, 'ph_project_access', true );

// if post status is set to private and the user isn't logged in
if ( $access == 'login' && ! is_user_logged_in() ) :

	ph_get_template_part( 'content', 'login' );

elseif ( post_password_required() ) :

	// get main content
	ph_get_template_part( 'content', 'password' );

else :

	// get custom header
	ph_get_template_part( 'header', 'project' );

	// @hooked ph_before_single_project
	do_action( 'ph_before_single_project' );

	// get main content
	ph_get_template_part( 'content', 'project' );

	// @hooked ph_after_single_project
	do_action( 'ph_after_single_project' );

	// get custom footer
	ph_get_template_part( 'footer', 'project' ); // get footer

endif;